/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Contents of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph


Revision 1.185 - (show annotations) (download)
Fri Mar 27 20:18:07 2009 UTC (10 years, 2 months ago) by jmc
Branch: MAIN
Changes since 1.184: +45 -3 lines
with option "-mpi": link *_mpi files from "MODS" dir
(this is what testreport does)

1 #! /usr/bin/env bash
2 #
3 # $Header: /u/gcmpack/MITgcm/tools/genmake2,v 1.184 2009/02/20 21:08:02 utke Exp $
4 #
5 # Makefile generator for MITgcm UV codes
6 # created by cnh 03/98
7 # adapted by aja 06/98
8 # modified by aja 01/00
9 # rewritten in bash by eh3 08/03
10
11 # Search for particular CPP #cmds associated with packages
12 # usage: test_for_package_in_cpp_options CPP_file package_name
13 test_for_package_in_cpp_options() {
14 cpp_options=$1
15 pkg=$2
16 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18 test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19 test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22 test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23 test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24 }
25
26 # Search for particular CPP #cmds associated with MPI
27 # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28 test_for_mpi_in_cpp_eeoptions() {
29 cpp_options=$1
30 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32 test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36 test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38 }
39
40 # Search for particular string in a file. Return 1 if detected, 0 if not
41 # usage: test_for_string_in_file file string
42 test_for_string_in_file() {
43 file=$1
44 strng=$2
45 grep -i "$strng" $file > /dev/null 2>&1
46 RETVAL=$?
47 if test "x${RETVAL}" = x0 ; then
48 printf "Error: In $file there is an illegal line: "
49 grep -i "$strng" $file
50 exit 99
51 fi
52 return 0
53 }
54
55 # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
56 # the package list.
57 expand_pkg_groups() {
58 new_packages=
59 PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
60 if test -r $PKG_GROUPS ; then
61 cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
62 cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
63 matched=0
64 for i in $PACKAGES ; do
65 line=`grep "^ *$i" ./p2.tmp`
66 RETVAL=$?
67 if test "x$RETVAL" = x0 ; then
68 matched=1
69 replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
70 echo " replacing \"$i\" with: $replace"
71 new_packages="$new_packages $replace"
72 else
73 new_packages="$new_packages $i"
74 fi
75 done
76 PACKAGES=$new_packages
77 rm -f ./p[1,2].tmp
78 return $matched
79 else
80 echo "Warning: can't read package groups definition file: $PKG_GROUPS"
81 fi
82 }
83
84 # Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
85 # cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
86 check_for_broken_Ff() {
87 # Do we have defaults for $FS and/or $FS90 ?
88 tfs=f
89 tfs9=f90
90 if test "x$FS" != x ; then
91 tfs="$FS"
92 fi
93 if test "x$FS90" != x ; then
94 tfs9="$FS90"
95 fi
96
97 # First check the ability to create a *.F/.f pair.
98 cat <<EOF >> genmake_hello.F
99 program hello
100 write(*,*) 'hi'
101 stop
102 end
103 EOF
104 cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
105 RETVAL=$?
106 if test "x$RETVAL" != x0 ; then
107 if test "x$FS" = x ; then
108 FS='for'
109 FS90='fr9'
110 check_for_broken_Ff
111 else
112 cat <<EOF 2>&1
113 ERROR: Your file system cannot distinguish between *.F and *.f files
114 (fails the "cp" test) and this program cannot find a suitable
115 replacement extension. Please try a different build environment or
116 contact the <MITgcm-support@mitgcm.org> list for help.
117
118 EOF
119 exit -1
120 fi
121 return
122 fi
123 rm -f genmake_hello.*
124
125 # Check the ability of ${MAKE} and ${LN} to use the current set
126 # of extensions.
127 cat <<EOF >> genmake_hello.F
128 program hello
129 write(*,*) 'hi'
130 stop
131 end
132 EOF
133 test -f $MAKEFILE && mv -f $MAKEFILE $MAKEFILE".tst"
134 cat <<EOF >> $MAKEFILE
135 .SUFFIXES:
136 .SUFFIXES: .$tfs .F
137 .F.$tfs:
138 $LN \$< \$@
139 EOF
140 $MAKE "genmake_hello."$tfs > /dev/null 2>&1
141 RETVAL=$?
142 if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
143 if test "x$FS" = x ; then
144 FS='for'
145 FS90='fr9'
146 check_for_broken_Ff
147 else
148 cat <<EOF 2>&1
149 ERROR: Your file system cannot distinguish between *.F and *.f files
150 (fails the "make/ln" test) and this program cannot find a suitable
151 replacement extension. Please try a different build environment or
152 contact the <MITgcm-support@mitgcm.org> list for help.
153
154 EOF
155 exit -1
156 return
157 fi
158 fi
159 rm -f genmake_hello.* $MAKEFILE
160 test -f $MAKEFILE".tst" && mv -f $MAKEFILE".tst" $MAKEFILE
161
162 # If we make it here, use the extensions
163 FS=$tfs
164 FS90=$tfs9
165 return
166 }
167
168
169 look_for_makedepend() {
170
171 # The "original" makedepend is part of the Imake system that is
172 # most often distributed with XFree86 or with an XFree86 source
173 # package. As a result, many machines (eg. generic Linux) do not
174 # have a system-default "makedepend" available. For those
175 # systems, we have two fall-back options:
176 #
177 # 1) a makedepend implementation shipped with the cyrus-imapd
178 # package: ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
179 #
180 # 2) a known-buggy xmakedpend shell script
181 #
182 # So the choices are, in order:
183 #
184 # 1) use the user-specified program
185 # 2) use a system-wide default
186 # 3) locally build and use the cyrus implementation
187 # 4) fall back to the buggy local xmakedpend script
188 #
189 if test "x${MAKEDEPEND}" = x ; then
190 which makedepend > /dev/null 2>&1
191 RV0=$?
192 test -f $MAKEFILE && mv -f $MAKEFILE $MAKEFILE".tst"
193 # echo 'MAKEFILE="'$MAKEFILE'"'
194 cat <<EOF >> $MAKEFILE
195 # THIS IS A TEST MAKEFILE GENERATED BY "genmake2"
196 #
197 # Some "makedepend" implementations will die if they cannot
198 # find a Makefile -- so this file is here to gives them an
199 # empty one to find and parse.
200 EOF
201 cat <<EOF >> genmake_tc.f
202 program test
203 write(*,*) 'test'
204 stop
205 end
206 EOF
207 makedepend genmake_tc.f > /dev/null 2>&1
208 RV1=$?
209 test -f $MAKEFILE && rm -f $MAKEFILE
210 test -f $MAKEFILE".tst" && mv -f $MAKEFILE".tst" $MAKEFILE
211 if test "x${RV0}${RV1}" = x00 ; then
212 MAKEDEPEND=makedepend
213 else
214 echo " a system-default makedepend was not found."
215
216 # Try to build the cyrus implementation
217 build_cyrus_makedepend
218 RETVAL=$?
219 if test "x$RETVAL" != x0 ; then
220 MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
221 fi
222 rm -f ./genmake_cy_md
223 fi
224 else
225 # echo "MAKEDEPEND=${MAKEDEPEND}"
226 echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
227 RETVAL=$?
228 if test x"$RETVAL" = x0 ; then
229 build_cyrus_makedepend
230 fi
231 fi
232 }
233
234
235 build_cyrus_makedepend() {
236 rm -f ./genmake_cy_md
237 (
238 cd $ROOTDIR/tools/cyrus-imapd-makedepend \
239 && ./configure > /dev/null 2>&1 \
240 && make > /dev/null 2>&1
241 if test -x ./makedepend.exe ; then
242 $LN ./makedepend.exe ./makedepend
243 fi
244 ./makedepend ifparser.c > /dev/null 2>&1 \
245 && echo "true"
246 ) > ./genmake_cy_md
247 grep true ./genmake_cy_md > /dev/null 2>&1
248 RETVAL=$?
249 rm -f ./genmake_cy_md
250 if test "x$RETVAL" = x0 ; then
251 MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
252 return 0
253 else
254 echo "WARNING: unable to build cyrus-imapd-makedepend"
255 return 1
256 fi
257 }
258
259
260 build_embed_encode()
261 {
262 printf " building the embed-encode utility... "
263 if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264 if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265 echo
266 echo " Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267 echo
268 EMBED_SRC=f
269 return 1
270 fi
271 clist="cc gcc c89 $CC"
272 for ic in $clist ; do
273 comm="$ic -o encode_files encode_files.c"
274 ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275 RETVAL=$?
276 if test "x$RETVAL" = x0 ; then
277 echo "OK"
278 DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279 return 0
280 fi
281 done
282 echo
283 echo " Error: unable to build $ROOTDIR/embed_encode/encode_files"
284 echo " so it has been disabled"
285 echo
286 EMBED_SRC=f
287 return 1
288 fi
289 echo "OK"
290 DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291 }
292
293
294 # Guess possible config options for this host
295 find_possible_configs() {
296
297 tmp1=`uname`"_"`uname -m`
298 tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
299 tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
300 tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
301 tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
302 tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
303 PLATFORM=$tmp3
304 echo $PLATFORM | grep cygwin > /dev/null 2>&1 && PLATFORM=cygwin_ia32
305 OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
306 echo " The platform appears to be: $PLATFORM"
307
308 echo "test" > test
309 ln -s ./test link
310 RETVAL=$?
311 if test "x${RETVAL}" = x0 ; then
312 LN="ln -s"
313 else
314 echo "Error: \"ln -s\" does not appear to work on this system!"
315 echo " For help, please contact <MITgcm-support@mitgcm.org>."
316 exit 1
317 fi
318 rm -f test link
319
320 if test "x$CPP" = x ; then
321 CPP="cpp -traditional -P"
322 fi
323
324 look_for_makedepend
325
326 #================================================================
327 # look for possible C compilers
328 tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329 p_CC=
330 for c in $tmp ; do
331 rm -f ./genmake_hello.c ./genmake_hello
332 cat >> genmake_hello.c << EOF
333 #include <stdio.h>
334 int main(int argc, char **argv) {
335 printf("Hello!\n");
336 return 0;
337 }
338 EOF
339 $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
340 RETVAL=$?
341 if test "x${RETVAL}" = x0 ; then
342 p_CC="$p_CC $c"
343 fi
344 done
345 rm -f ./genmake_hello.c ./genmake_hello
346 if test "x${p_CC}" = x ; then
347 cat 1>&2 <<EOF
348
349 Error: No C compilers were found in your path. Please specify one using:
350
351 1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
352 2) the CC or MITGCM_CC environment variables.
353
354 EOF
355 exit 1
356 else
357 echo " The possible C compilers found in your path are:"
358 echo " "$p_CC
359 if test "x$CC" = x ; then
360 CC=`echo $p_CC | $AWK '{print $1}'`
361 echo " Setting C compiler to: "$CC
362 fi
363 fi
364
365 #================================================================
366 # look for possible FORTRAN compilers
367 tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368 p_FC=
369 for c in $tmp ; do
370 rm -f ./hello.f ./hello
371 cat >> hello.f <<EOF
372 program hello
373 do i=1,3
374 print *, 'hello world : ', i
375 enddo
376 end
377 EOF
378 $c -o hello hello.f > /dev/null 2>&1
379 RETVAL=$?
380 if test "x${RETVAL}" = x0 ; then
381 p_FC="$p_FC $c"
382 fi
383 done
384 rm -f ./hello.f ./hello
385 if test "x${p_FC}" = x ; then
386 cat 1>&2 <<EOF
387
388 Error: No Fortran compilers were found in your path. Please specify one using:
389
390 1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
391 2) a command-line option (eg. "-fc NAME"), or
392 3) the FC or MITGCM_FC environment variables.
393
394 EOF
395 exit 1
396 else
397 echo " The possible FORTRAN compilers found in your path are:"
398 echo " "$p_FC
399 fi
400
401 # Use the first of the compilers found in the current PATH
402 # that has a correctly-named optfile
403 if test "x$OPTFILE" = x -a "x$FC" = x ; then
404 for i in $p_FC ; do
405 OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
406 if test -r $OPTFILE ; then
407 echo " Setting OPTFILE to: "$OPTFILE
408 break
409 fi
410 done
411 fi
412
413 if test "x$OPTFILE" = x ; then
414 OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
415 if test ! -r $OPTFILE ; then
416 echo " I looked for the file "$OPTFILE" but did not find it"
417 fi
418 fi
419 # echo " The options file: $p_OF"
420 # echo " appears to match so we'll use it."
421 # for i in $p_FC ; do
422 #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
423 #if test -r $p_OF ; then
424 # OPTFILE=$p_OF
425 # echo " The options file: $p_OF"
426 # echo " appears to match so we'll use it."
427 # break
428 #fi
429 # done
430 if test "x$OPTFILE" = x ; then
431 cat 1>&2 <<EOF
432
433 Error: No options file was found in: $ROOTDIR/tools/build_options/
434 that matches this platform ("$PLATFORM") and the compilers found in
435 your path. Please specify an "optfile" using:
436
437 1) the command line (eg. "-optfile=path/to/OPTFILE"), or
438 2) the MITGCM_OF environment variable.
439
440 If you need help, please contact the developers at <MITgcm-support@mitgcm.org>.
441
442 EOF
443 exit 1
444 fi
445
446 # # look for possible MPI libraries
447 # mpi_libs=
448 # mpi_fort=`which mpif77 2>/dev/null`
449 # RETVAL=$?
450 # if test "x${RETVAL}" = x0 ; then
451 # cat >>test.f <<EOF
452 # PROGRAM HELLO
453 # DO 10, I=1,10
454 # PRINT *,'Hello World'
455 # 10 CONTINUE
456 # STOP
457 # END
458 # EOF
459 # eval "$mpi_fort -showme test.f > out"
460 # RETVAL=$?
461 # if test "x${RETVAL}" = x0 ; then
462 # a=`cat out`
463 # for i in $a ; do
464 # case $i in
465 # -*)
466 # mpi_libs="$mpi_libs $i" ;;
467 # esac
468 # done
469 # echo "The MPI libs appear to be:"
470 # echo " "$mpi_libs
471 # fi
472 # rm -f test.f out
473 # fi
474
475 }
476
477 # Parse the package dependency information
478 get_pdepend_list() {
479
480 # strip the comments and then convert the dependency file into
481 # two arrays: PNAME, DNAME
482 cat $1 | sed -e 's/#.*$//g' \
483 | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
484 > ./.pd_tmp
485 . ./.pd_tmp
486 rm -f ./.pd_tmp
487
488 printf "PNAME = "${}
489 }
490
491
492 # Explain usage
493 usage() {
494 cat <<EOF
495
496 Usage: "$0" [OPTIONS]
497 where [OPTIONS] can be:
498
499 -help | --help | -h | --h
500 Print this help message and exit.
501
502 -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
503 -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
504 Use "NAME" as the adoptfile. By default, the file at
505 "tools/adjoint_options/adjoint_default" will be used.
506
507 -nooptfile | --nooptfile
508 -optfile NAME | --optfile NAME | -of NAME | --of NAME
509 -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
510 Use "NAME" as the optfile. By default, an attempt will be
511 made to find an appropriate "standard" optfile in the
512 tools/build_options/ directory.
513
514 -pdepend NAME | --pdepend NAME
515 -pdepend=NAME | --pdepend=NAME
516 Get package dependency information from "NAME".
517
518 -pdefault NAME | --pdefault NAME
519 -pdefault=NAME | --pdefault=NAME
520 Get the default package list from "NAME".
521
522 -make NAME | -m NAME
523 --make=NAME | -m=NAME
524 Use "NAME" for the MAKE program. The default is "make" but
525 many platforms, "gmake" is the preferred choice.
526
527 -makefile NAME | -mf NAME
528 --makefile=NAME | -mf=NAME
529 Call the makefile "NAME". The default is "Makefile".
530
531 -makedepend NAME | -md NAME
532 --makedepend=NAME | -md=NAME
533 Use "NAME" for the MAKEDEPEND program.
534
535 -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
536 -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
537 Specify the location of the MITgcm ROOTDIR as "NAME".
538 By default, genamke will try to find the location by
539 looking in parent directories (up to the 5th parent).
540
541 -mods NAME | --mods NAME | -mo NAME | --mo NAME
542 -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
543 Here, "NAME" specifies a list of directories that are
544 used for additional source code. Files found in the
545 "mods list" are given preference over files of the same
546 name found elsewhere.
547
548 -disable NAME | --disable NAME
549 -disable=NAME | --disable=NAME
550 Here "NAME" specifies a list of packages that we don't
551 want to use. If this violates package dependencies,
552 genamke will exit with an error message.
553
554 -enable NAME | --enable NAME
555 -enable=NAME | --enable=NAME
556 Here "NAME" specifies a list of packages that we wish
557 to specifically enable. If this violates package
558 dependencies, genamke will exit with an error message.
559
560 -standarddirs NAME | --standarddirs NAME
561 -standarddirs=NAME | --standarddirs=NAME
562 Here, "NAME" specifies a list of directories to be
563 used as the "standard" code.
564
565 -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
566 -fc=NAME | --fc=NAME
567 Use "NAME" as the fortran compiler. By default, genmake
568 will search for a working compiler by trying a list of
569 "usual suspects" such as g77, f77, etc.
570
571 -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
572 Use "NAME" as the C compiler. By default, genmake
573 will search for a working compiler by trying a list of
574 "usual suspects" such as gcc, c89, cc, etc.
575
576 -[no]ieee | --[no]ieee
577 Do or don't use IEEE numerics. Note that this option
578 *only* works if it is supported by the OPTFILE that
579 is being used.
580
581 -ignoretime | -ignore_time | --ignoretime | --ignore_time
582 Ignore all the "wall clock" routines entirely. This will
583 not in any way hurt the model results -- it simply means
584 that the code that checks how long the model spends in
585 various routines will give junk values.
586
587 -ts | --ts
588 Produce timing information per timestep
589 -papis | --papis
590 Produce summary MFlop/s (and IPC) with PAPI per timestep
591 -pcls | --pcls
592 Produce summary MFlop/s etc. with PCL per timestep
593 -foolad | --foolad
594 Fool the AD code generator
595 -papi | --papi
596 Performance analysis with PAPI
597 -pcl | --pcl
598 Performance analysis with PCL
599 -hpmt | --hpmt
600 Performance analysis with the HPM Toolkit
601
602 -gsl | --gsl
603 Use GSL to control floating point rounding and precision
604 -devel | --devel
605 Add additional warning and debugging flags for development
606
607 -mpi | --mpi
608 Include MPI header files and link to MPI libraries
609 -mpi=PATH | --mpi=PATH
610 Include MPI header files and link to MPI libraries using MPI_ROOT
611 set to PATH. i.e. Include files from \$PATH/include, link to libraries
612 from \$PATH/lib and use binaries from \$PATH/bin.
613
614 -es | --es | -embed-source | --embed-source
615 Embed a tarball containing the full source code
616 (including the Makefile, etc.) used to build the
617 executable [off by default]
618
619 -bash NAME
620 Explicitly specify the Bourne or BASH shell to use
621
622 While it is most often a single word, the "NAME" variables specified
623 above can in many cases be a space-delimited string such as:
624
625 --enable pkg1 --enable 'pkg1 pkg2' --enable 'pkg1 pkg2 pkg3'
626 -mods=dir1 -mods='dir1' -mods='dir1 dir2 dir3'
627 -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
628
629 which, depending upon your shell, may need to be single-quoted.
630
631 For more detailed genmake documentation, please see:
632
633 http://mitgcm.org/devel_HOWTO/
634
635 EOF
636
637 exit 1
638 }
639
640 # Build a CPP macro to automate calling C routines from FORTRAN
641 get_fortran_c_namemangling() {
642
643 #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
644 if test ! "x$FC_NAMEMANGLE" = x ; then
645 return 0
646 fi
647
648 default_nm="#define FC_NAMEMANGLE(X) X ## _"
649
650 cat > genmake_test.c <<EOF
651 void tcall( char * string ) { tsub( string ); }
652 EOF
653 $MAKE genmake_test.o >> genmake_warnings 2>&1
654 RETVAL=$?
655 if test "x$RETVAL" != x0 ; then
656 FC_NAMEMANGLE=$default_nm
657 cat <<EOF>> genmake_errors
658
659 WARNING: C test compile fails
660 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
661 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
662 EOF
663 return 1
664 fi
665 c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
666 RETVAL=$?
667 if test "x$RETVAL" != x0 ; then
668 FC_NAMEMANGLE=$default_nm
669 cat <<EOF>> genmake_warnings
670
671 WARNING: The "nm" command failed.
672 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
673 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
674 EOF
675 return 1
676 fi
677 cat > genmake_tcomp.$FS <<EOF
678 subroutine tcall( string )
679 character*(*) string
680 call tsub( string )
681 end
682 EOF
683 $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1
684 RETVAL=$?
685 if test "x$RETVAL" != x0 ; then
686 FC_NAMEMANGLE=$default_nm
687 cat <<EOF>> genmake_warnings
688
689 WARNING: FORTRAN test compile fails -- please see "genmake_errors"
690 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
691 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
692 EOF
693 return 1
694 fi
695 f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
696 RETVAL=$?
697 if test "x$RETVAL" != x0 ; then
698 FC_NAMEMANGLE=$default_nm
699 cat <<EOF>> genmake_warnings
700
701 WARNING: The "nm" command failed.
702 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
703 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
704 EOF
705 return 1
706 fi
707
708 c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
709 f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
710 c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
711 f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
712
713 nmangle="X"
714 if test "x$c_a" != "x$f_a" ; then
715 comm="echo x$f_a | sed -e 's|x$c_a||'"
716 a=`eval $comm`
717 nmangle="$a ## $nmangle"
718 fi
719 if test "x$c_b" != "x$f_b" ; then
720 comm="echo x$f_b | sed -e 's|x$c_b||'"
721 b=`eval $comm`
722 nmangle="$nmangle ## $b"
723 fi
724
725 FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) $nmangle"
726
727 # cleanup the testing files
728 rm -f genmake_tcomp.* genmake_test.*
729 }
730
731
732 check_HAVE_CLOC() {
733 get_fortran_c_namemangling
734 cat <<EOF > genmake_tc_1.c
735 $FC_NAMEMANGLE
736 #include <stdio.h>
737 #include <stdlib.h>
738 #include <unistd.h>
739 #include <assert.h>
740 #include <sys/time.h>
741 void FC_NAMEMANGLE(cloc) ( double *curtim )
742 {
743 struct timeval tv1;
744 gettimeofday(&tv1 , (void *)NULL );
745 *curtim = (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
746 *curtim = *curtim/1.E6;
747 }
748 EOF
749 COMM="$CC $CFLAGS -c genmake_tc_1.c"
750 echo $COMM >> genmake_warnings
751 $COMM >> genmake_warnings 2>&1
752 RET_C=$?
753 cat <<EOF > genmake_tc_2.$FS
754 program hello
755 REAL*8 wtime
756 external cloc
757 call cloc(wtime)
758 print *," HELLO WORLD", wtime
759 end
760 EOF
761 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
762 echo $COMM >> genmake_warnings
763 $COMM >> genmake_warnings 2>&1
764 RET_F=$?
765 test -x ./genmake_tc && ./genmake_tc >> genmake_warnings 2>&1
766 RETVAL=$?
767 if test "x$RETVAL" = x0 ; then
768 HAVE_CLOC=t
769 DEFINES="$DEFINES -DHAVE_CLOC"
770 fi
771 rm -f genmake_tc*
772 }
773
774
775 check_HAVE_SIGREG() {
776 if test ! "x$HAVE_SIGREG" = x ; then
777 return
778 fi
779 get_fortran_c_namemangling
780 cat <<EOF > genmake_tc_1.c
781 $FC_NAMEMANGLE
782 #include <stdlib.h>
783 #include <stdio.h>
784 #include <signal.h>
785 #include <errno.h>
786 #include <ucontext.h>
787
788 int * ip;
789
790 static void killhandler(
791 unsigned int sn, siginfo_t si, struct ucontext *sc )
792 {
793 *ip = *ip + 1;
794 return;
795 }
796
797 void FC_NAMEMANGLE(sigreg) (int * aip)
798 {
799 struct sigaction s;
800 ip = aip;
801 s.sa_flags = SA_SIGINFO;
802 s.sa_sigaction = (void *)killhandler;
803 if(sigaction (SIGTERM,&s,(struct sigaction *)NULL)) {
804 printf("Sigaction returned error = %d\n", errno);
805 exit(0);
806 }
807 return;
808 }
809 EOF
810 COMM="$CC $CFLAGS -c genmake_tc_1.c"
811 echo $COMM >> genmake_warnings
812 $COMM >> genmake_warnings 2>&1
813 RET_C=$?
814 cat <<EOF > genmake_tc_2.$FS
815 program hello
816 integer anint
817 common /iv/ anint
818 external sigreg
819 call sigreg(anint)
820 end
821 EOF
822 echo >> genmake_warnings
823 echo "running: check_HAVE_SIGREG()" >> genmake_warnings
824 cat genmake_tc_2.$FS >> genmake_warnings
825 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
826 echo $COMM >> genmake_warnings
827 $COMM >> genmake_warnings 2>&1
828 RETVAL=$?
829 if test "x$RETVAL" = x0 ; then
830 HAVE_SIGREG=t
831 DEFINES="$DEFINES -DHAVE_SIGREG"
832 fi
833 rm -f genmake_tc*
834 }
835
836
837 check_HAVE_SETRLSTK() {
838 if test "x$HAVE_SETRLSTK" = xt ; then
839 DEFINES="$DEFINES -DHAVE_SETRLSTK"
840 return
841 fi
842 if test ! "x$HAVE_SETRLSTK" = x ; then
843 return
844 fi
845 get_fortran_c_namemangling
846 cat <<EOF > genmake_tc_1.c
847 $FC_NAMEMANGLE
848 #include <sys/time.h>
849 #include <sys/resource.h>
850 #include <unistd.h>
851 void FC_NAMEMANGLE(setrlstk) ()
852 {
853 struct rlimit rls;
854 rls.rlim_cur = RLIM_INFINITY;
855 rls.rlim_max = RLIM_INFINITY;
856 setrlimit(RLIMIT_STACK, &rls);
857 return;
858 }
859 EOF
860 COMM="$CC $CFLAGS -c genmake_tc_1.c"
861 echo $COMM >> genmake_warnings
862 $COMM >> genmake_warnings 2>&1
863 RET_C=$?
864 cat <<EOF > genmake_tc_2.$FS
865 program hello
866 external setrlstk
867 call setrlstk()
868 end
869 EOF
870 echo >> genmake_warnings
871 echo "running: check_HAVE_SETRLSTK()" >> genmake_warnings
872 cat genmake_tc_2.$FS >> genmake_warnings
873 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
874 echo $COMM >> genmake_warnings
875 $COMM >> genmake_warnings 2>&1
876 RETVAL=$?
877 if test "x$RETVAL" = x0 ; then
878 HAVE_SETRLSTK=t
879 DEFINES="$DEFINES -DHAVE_SETRLSTK"
880 fi
881 rm -f genmake_tc*
882 }
883
884
885 check_HAVE_STAT() {
886 get_fortran_c_namemangling
887 cat <<EOF > genmake_tc_1.c
888 $FC_NAMEMANGLE
889 #include <stdio.h>
890 #include <stdlib.h>
891 #include <unistd.h>
892 #include <sys/stat.h>
893 #include <sys/types.h>
894 void FC_NAMEMANGLE(tfsize) ( int *nbyte )
895 {
896 char name[512];
897 struct stat astat;
898
899 name[0] = 'a'; name[1] = '\0';
900 if (! stat(name, &astat))
901 *nbyte = (int)(astat.st_size);
902 else
903 *nbyte = -1;
904 }
905 EOF
906 COMM="$CC $CFLAGS -c genmake_tc_1.c"
907 echo $COMM >> genmake_warnings
908 $COMM >> genmake_tc.log 2>&1
909 RET_C=$?
910 cat <<EOF > genmake_tc_2.$FS
911 program hello
912 integer nbyte
913 call tfsize(nbyte)
914 print *," HELLO WORLD", nbyte
915 end
916 EOF
917 echo >> genmake_warnings
918 echo "running: check_HAVE_STAT()" >> genmake_warnings
919 cat genmake_tc_2.$FS >> genmake_warnings
920 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
921 echo $COMM >> genmake_warnings
922 $COMM >> genmake_tc.log 2>&1
923 RETVAL=$?
924 if test "x$RETVAL" = x0 ; then
925 HAVE_STAT=t
926 DEFINES="$DEFINES -DHAVE_STAT"
927 fi
928 rm -f genmake_tc*
929 }
930
931
932 check_netcdf_libs() {
933 if test ! "x$SKIP_NETCDF_CHECK" = x ; then
934 return
935 fi
936 echo >> genmake_warnings
937 echo "running: check_netcdf_libs()" >> genmake_warnings
938 cat <<EOF > genmake_tnc.F
939 program fgennc
940 #include "netcdf.inc"
941 EOF
942 if test ! "x$MPI" = x ; then
943 echo '#include "mpif.h"' >> genmake_tnc.F
944 fi
945 cat <<EOF >> genmake_tnc.F
946 integer iret, ncid, xid
947 iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
948 IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
949 iret = nf_def_dim(ncid, 'X', 11, xid)
950 IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
951 iret = nf_close(ncid)
952 IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
953 end
954 EOF
955 echo "=== genmake_tnc.F ===" > genmake_tnc.log
956 cat genmake_tnc.F >> genmake_tnc.log
957 echo "=== genmake_tnc.F ===" >> genmake_tnc.log
958 RET_CPP=f
959 COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
960 echo "$COMM" >> genmake_tnc.log
961 eval $COMM > genmake_tnc.$FS 2>/dev/null && RET_CPP=t
962 if test "x$RET_CPP" = xf ; then
963 echo " WARNING: CPP failed to pre-process the netcdf test." \
964 >> genmake_tnc.log
965 echo " Please check that \$INCLUDES is properly set." \
966 >> genmake_tnc.log
967 fi
968 echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
969 echo " && $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
970 $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1 \
971 && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
972 RET_COMPILE=$?
973 cat genmake_tnc.log >> genmake_warnings
974
975 #EH3 Remove test program execution for machines that either disallow
976 #EH3 execution or cannot support it (eg. cross-compilers)
977 #EH3
978 #EH3 test -x ./genmake_tnc && ./genmake_tnc >> genmake_tnc.log 2>&1
979 #EH3 RETVAL=$?
980 #EH3 if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
981
982 if test "x$RET_COMPILE" = x0 ; then
983 HAVE_NETCDF=t
984 else
985 # try again with "-lnetcdf" added to the libs
986 echo "try again with added '-lnetcdf'" > genmake_tnc.log
987 echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
988 echo " && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
989 echo " && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
990 cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null \
991 && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1 \
992 && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
993 RET_COMPILE=$?
994 cat genmake_tnc.log >> genmake_warnings
995 if test "x$RET_COMPILE" = x0 ; then
996 LIBS="$LIBS -lnetcdf"
997 HAVE_NETCDF=t
998 else
999 # try again with "-lnetcdff" added to the libs
1000 echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
1001 echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
1002 echo " && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
1003 echo " && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
1004 cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null \
1005 && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1 \
1006 && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
1007 RET_COMPILE=$?
1008 cat genmake_tnc.log >> genmake_warnings
1009 if test "x$RET_COMPILE" = x0 ; then
1010 LIBS="$LIBS -lnetcdff -lnetcdf"
1011 HAVE_NETCDF=t
1012 fi
1013 fi
1014 fi
1015 rm -f genmake_tnc*
1016 }
1017
1018
1019
1020 ###############################################################################
1021 # Sequential part of script starts here
1022 ###############################################################################
1023
1024 # Set defaults here
1025 COMMANDL="$0 $@"
1026
1027 PLATFORM=
1028 LN=
1029 S64=
1030 KPP=
1031 #FC=
1032 #CC=gcc
1033 #CPP=
1034 LINK=
1035 DEFINES=
1036 PACKAGES=
1037 ENABLE=
1038 DISABLE=
1039 # MAKEFILE=
1040 # MAKEDEPEND=
1041 PDEPEND=
1042 DUMPSTATE=t
1043 PDEFAULT=
1044 OPTFILE=
1045 INCLUDES="-I. $INCLUDES"
1046 FFLAGS=
1047 FOPTIM=
1048 FEXTRAFLAGS=
1049 USE_EXTENDED_SRC=
1050 EXTENDED_SRC_FLAG=
1051 CFLAGS=
1052 KFLAGS1=
1053 KFLAGS2=
1054 #LDADD=
1055 LIBS=
1056 KPPFILES=
1057 NOOPTFILES=
1058 NOOPTFLAGS=
1059 MPI=
1060 MPIPATH=
1061 TS=
1062 PAPIS=
1063 PCLS=
1064 FOOLAD=
1065 PAPI=
1066 PCL=
1067 HPMT=
1068 GSL=
1069 DEVEL=
1070 HAVE_TEST_L=
1071
1072 # DEFINES checked by test compilation or command-line
1073 HAVE_SYSTEM=
1074 HAVE_FDATE=
1075 FC_NAMEMANGLE=
1076 HAVE_CLOC=
1077 # HAVE_SETRLSTK=
1078 HAVE_STAT=
1079 HAVE_NETCDF=
1080 HAVE_ETIME=
1081 IGNORE_TIME=
1082
1083 MODS=
1084 TOOLSDIR=
1085 SOURCEDIRS=
1086 INCLUDEDIRS=
1087 STANDARDDIRS="USE_THE_DEFAULT"
1088
1089 G2ARGS=
1090 BASH=
1091 PWD=`pwd`
1092 test "x$MAKE" = x && MAKE=make
1093 test "x$AWK" = x && AWK=awk
1094 EMBED_SRC=
1095 THISHOST=`hostname`
1096 THISCWD=`pwd`
1097 THISDATE=`date`
1098 THISUSER=`echo $USER`
1099 THISVER=
1100 MACHINE=`uname -a`
1101 EXECUTABLE=
1102 EXEHOOK=
1103 EXEDIR=
1104 PACKAGES_CONF=
1105 IEEE=
1106 if test "x$MITGCM_IEEE" != x ; then
1107 IEEE=$MITGCM_IEEE
1108 fi
1109 FS=
1110 FS90=
1111
1112 AUTODIFF_PKG_USED=f
1113 AD_OPTFILE=
1114 TAF=
1115 AD_TAF_FLAGS=
1116 FTL_TAF_FLAGS=
1117 SVD_TAF_FLAGS=
1118 TAF_EXTRA=
1119 TAMC=
1120 AD_TAMC_FLAGS=
1121 FTL_TAF_FLAGS=
1122 SVD_TAMC_FLAGS=
1123 TAMC_EXTRA=
1124
1125
1126 # The following state can be set directly by command-line switches
1127 gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1128 gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI JAM DUMPSTATE STANDARDDIRS"
1129
1130 # The following state is not directly set by command-line switches
1131 gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM FEXTRAFLAGS"
1132 gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
1133 gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
1134 gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
1135 gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
1136
1137 # The following are all related to adjoint/tangent-linear stuff
1138 gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
1139 gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
1140 gm_s12="TAF_EXTRA TAMC_EXTRA"
1141
1142 gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
1143 gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
1144
1145 cat <<EOF
1146
1147 GENMAKE :
1148
1149 A program for GENerating MAKEfiles for the MITgcm project. For a
1150 quick list of options, use "genmake -h" or for more detail see:
1151
1152 http://mitgcm.org/devel_HOWTO/
1153
1154 EOF
1155
1156 echo "=== Processing options files and arguments ==="
1157 gm_local="genmake_local"
1158 printf " getting local config information: "
1159 if test -f $gm_local ; then
1160 echo "using $gm_local"
1161 . $gm_local
1162 # echo "DISABLE=$DISABLE"
1163 # echo "ENABLE=$ENABLE"
1164 else
1165 echo "none found"
1166 fi
1167
1168 #echo "$0::$1:$2:$3:$4:$5:$6:$7:"
1169 #OPTIONS=
1170 #n=0
1171 #for i ; do
1172 # echo "$i $n"
1173 # setvar="OPTIONS[$n]='$i'"
1174 # # echo " $setvar"
1175 # eval "$setvar"
1176 # n=$(( $n + 1 ))
1177 #done
1178 #parse_options
1179 ac_prev=
1180 for ac_option in "$@" ; do
1181
1182 G2ARGS="$G2ARGS \"$ac_option\""
1183
1184 # If the previous option needs an argument, assign it.
1185 if test -n "$ac_prev"; then
1186 eval "$ac_prev=\$ac_option"
1187 ac_prev=
1188 continue
1189 fi
1190
1191 ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`
1192
1193 case $ac_option in
1194
1195 -help | --help | -h | --h)
1196 usage ;;
1197
1198 -nooptfile | --nooptfile)
1199 OPTFILE="NONE" ;;
1200 -optfile | --optfile | -of | --of)
1201 ac_prev=OPTFILE ;;
1202 -optfile=* | --optfile=* | -of=* | --of=*)
1203 OPTFILE=$ac_optarg ;;
1204
1205 -adoptfile | --adoptfile | -adof | --adof)
1206 ac_prev=AD_OPTFILE ;;
1207 -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
1208 AD_OPTFILE=$ac_optarg ;;
1209
1210 -pdepend | --pdepend)
1211 ac_prev=PDEPEND ;;
1212 -pdepend=* | --pdepend=*)
1213 PDEPEND=$ac_optarg ;;
1214
1215 -pdefault | --pdefault)
1216 ac_prev=PDEFAULT ;;
1217 -pdefault=* | --pdefault=*)
1218 PDEFAULT=$ac_optarg ;;
1219
1220 -make | --make | -m | --m)
1221 ac_prev=MAKE ;;
1222 -make=* | --make=* | -m=* | --m=*)
1223 MAKE=$ac_optarg ;;
1224
1225 -bash | --bash)
1226 ac_prev=BASH ;;
1227 -bash=* | --bash=*)
1228 BASH=$ac_optarg ;;
1229
1230 -makedepend | --makedepend | -md | --md)
1231 ac_prev=MAKEDEPEND ;;
1232 -makedepend=* | --makedepend=* | -md=* | --md=*)
1233 MAKEDEPEND=$ac_optarg ;;
1234
1235 -makefile | --makefile | -ma | --ma)
1236 ac_prev=MAKEFILE ;;
1237 -makefile=* | --makefile=* | -ma=* | --ma=*)
1238 MAKEFILE=$ac_optarg ;;
1239
1240 -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
1241 echo "ERROR: The platform option has been removed. Please specify"
1242 echo " the build options using the \"optfile\" mechanism."
1243 echo
1244 usage
1245 ;;
1246
1247 -rootdir | --rootdir | -rd | --rd)
1248 ac_prev=ROOTDIR ;;
1249 -rootdir=* | --rootdir=* | -rd=* | --rd=*)
1250 ROOTDIR=$ac_optarg ;;
1251
1252 -mods | --mods | -mo | --mo)
1253 ac_prev=MODS ;;
1254 -mods=* | --mods=* | -mo=* | --mo=*)
1255 MODS=$ac_optarg ;;
1256
1257 -disable | --disable)
1258 ac_prev=DISABLE ;;
1259 -disable=* | --disable=*)
1260 DISABLE=$ac_optarg ;;
1261
1262 -enable | --enable)
1263 ac_prev=ENABLE ;;
1264 -enable=* | --enable=*)
1265 ENABLE=$ac_optarg ;;
1266
1267 -standarddirs | --standarddirs)
1268 ac_prev=STANDARDDIRS ;;
1269 -standarddirs=* | --standarddirs=*)
1270 STANDARDDIRS=$ac_optarg ;;
1271
1272 # -cpp | --cpp)
1273 # ac_prev=cpp ;;
1274 # -cpp=* | --cpp=*)
1275 # CPP=$ac_optarg ;;
1276
1277 -cc | --cc)
1278 ac_prev=CC ;;
1279 -cc=* | --cc=*)
1280 CC=$ac_optarg ;;
1281
1282 -fortran | --fortran | -fc | --fc)
1283 ac_prev=FC ;;
1284 -fc=* | --fc=*)
1285 FC=$ac_optarg ;;
1286
1287 -fs | --fs)
1288 ac_prev=FS ;;
1289 -fs=* | --fs=*)
1290 FS=$ac_optarg ;;
1291
1292 -fs90 | --fs90)
1293 ac_prev=FS90 ;;
1294 -fs90=* | --fs90=*)
1295 FS90=$ac_optarg ;;
1296
1297 -ieee | --ieee)
1298 IEEE=true ;;
1299 -noieee | --noieee)
1300 IEEE= ;;
1301
1302 -ts | --ts)
1303 TS=true ;;
1304 -papis | --papis)
1305 PAPIS=true ;;
1306 -pcls | --pcls)
1307 PCLS=true ;;
1308 -foolad | --foolad)
1309 FOOLAD=true ;;
1310 -papi | --papi)
1311 PAPI=true ;;
1312 -pcl | --pcl)
1313 PCL=true ;;
1314 -hpmt | --hpmt)
1315 HPMT=true ;;
1316
1317 -gsl | --gsl)
1318 GSL=true ;;
1319
1320 -devel | --devel)
1321 DEVEL=true ;;
1322
1323 -mpi | --mpi)
1324 MPI=true ;;
1325 -mpi=* | --mpi=*)
1326 MPIPATH=$ac_optarg
1327 MPI=true ;;
1328
1329 # -jam | --jam)
1330 # JAM=1 ;;
1331 # -nojam | --nojam)
1332 # JAM=0 ;;
1333
1334 -ds | --ds)
1335 DUMPSTATE=t ;;
1336
1337 -taf_extra | --taf_extra)
1338 ac_prev=TAF_EXTRA ;;
1339 -taf_extra=* | --taf_extra=*)
1340 TAF_EXTRA=$ac_optarg ;;
1341
1342 -tamc_extra | --tamc_extra)
1343 ac_prev=TAMC_EXTRA ;;
1344 -tamc_extra=* | --tamc_extra=*)
1345 TAMC_EXTRA=$ac_optarg ;;
1346
1347 -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1348 IGNORE_TIME="-DIGNORE_TIME" ;;
1349
1350 -es | --es | -embed-source | --embed-source)
1351 EMBED_SRC=t ;;
1352
1353 -*)
1354 echo "Error: unrecognized option: "$ac_option
1355 usage
1356 ;;
1357
1358 *)
1359 echo "Error: unrecognized argument: "$ac_option
1360 usage
1361 ;;
1362
1363 esac
1364
1365 done
1366
1367
1368 if test -f ./.genmakerc ; then
1369 echo
1370 echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1371 echo " file. This file format is no longer supported. For directions on"
1372 echo " how to setup and use the new \"genmake2\" script, please see:"
1373 echo " http://mitgcm.org/devel_HOWTO/"
1374 echo " and send an email to MITgcm-support@mitgcm.org if you need help."
1375 echo "WARNING: ignore \"./.genmakerc\" and continue."
1376 echo
1377 fi
1378
1379 # Find the MITgcm ${ROOTDIR}
1380 if test "x${ROOTDIR}" = x ; then
1381 tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1382 if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1383 ROOTDIR=".."
1384 else
1385 for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
1386 if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
1387 ROOTDIR=$d
1388 printf "Warning: ROOTDIR was not specified but there appears to be"
1389 echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
1390 break
1391 fi
1392 done
1393 fi
1394 fi
1395 if test "x${ROOTDIR}" = x ; then
1396 echo "Error: Cannot determine ROOTDIR for MITgcm code."
1397 echo " Please specify a ROOTDIR using either an options "
1398 echo " file or a command-line option."
1399 exit 1
1400 fi
1401 if test ! -d ${ROOTDIR} ; then
1402 echo "Error: the specified ROOTDIR (\"$ROOTDIR\") does not exist!"
1403 exit 1
1404 fi
1405
1406 # Find the MITgcm ${THISVER}
1407 version_file="${ROOTDIR}/doc/tag-index"
1408 if test -f $version_file ; then
1409 THISVER=`grep '^checkpoint' $version_file | head -1`
1410 #- remove ./BUILD_INFO.h file if older than version_file
1411 if test -f ./BUILD_INFO.h -a ./BUILD_INFO.h -ot $version_file ; then
1412 echo " remove ./BUILD_INFO.h (older than ${version_file})"
1413 rm -f ./BUILD_INFO.h
1414 fi
1415 fi
1416
1417 if test "x$MAKEFILE" = x ; then
1418 MAKEFILE="Makefile"
1419 fi
1420
1421 echo " getting OPTFILE information: "
1422 if test "x${OPTFILE}" = x ; then
1423 if test "x$MITGCM_OF" = x ; then
1424 echo "Warning: no OPTFILE specified so we'll look for possible settings"
1425 printf "\n=== Searching for possible settings for OPTFILE ===\n"
1426 find_possible_configs
1427 else
1428 OPTFILE=$MITGCM_OF
1429 fi
1430 fi
1431 if test "x$OPTFILE" != xNONE ; then
1432 if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
1433 echo " using OPTFILE=\"$OPTFILE\""
1434 . "$OPTFILE"
1435 RETVAL=$?
1436 if test "x$RETVAL" != x0 ; then
1437 printf "Error: failed to source OPTFILE \"$OPTFILE\""
1438 echo "--please check that variable syntax is bash-compatible"
1439 exit 1
1440 fi
1441 if test "x$DUMPSTATE" != xf ; then
1442 cp -f $OPTFILE "genmake_optfile"
1443 fi
1444 else
1445 echo "Error: can't read OPTFILE=\"$OPTFILE\""
1446 exit 1
1447 fi
1448 fi
1449
1450 echo " getting AD_OPTFILE information: "
1451 if test "x${AD_OPTFILE}" = x ; then
1452 if test "x$MITGCM_AD_OF" = x ; then
1453 AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
1454 else
1455 AD_OPTFILE=$MITGCM_AD_OF
1456 fi
1457 fi
1458 if test "x${AD_OPTFILE}" != xNONE ; then
1459 if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
1460 echo " using AD_OPTFILE=\"$AD_OPTFILE\""
1461 . "$AD_OPTFILE"
1462 RETVAL=$?
1463 if test "x$RETVAL" != x0 ; then
1464 printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1465 echo "--please check that variable syntax is bash-compatible"
1466 exit 1
1467 fi
1468 if test "x$DUMPSTATE" != xf ; then
1469 cp -f $AD_OPTFILE "genmake_ad_optfile"
1470 fi
1471 else
1472 echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
1473 exit 1
1474 fi
1475 fi
1476
1477 #====================================================================
1478 # Set default values if not set by the optfile
1479 #
1480 # Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined. If not,
1481 # either set defaults or complain and abort!
1482 if test ! "x$BASH" = x ; then
1483 # add a trailing space so that it works within the Makefile syntax (see below)
1484 BASH="$BASH "
1485 fi
1486 if test "x$FC" = x ; then
1487 cat <<EOF 1>&2
1488
1489 Error: no Fortran compiler: please specify using one of the following:
1490 1) within the options file ("FC=...") as specified by "-of=OPTFILE"
1491 2) the "-fc=XXX" command-line option
1492 3) the "./genmake_local" file
1493 EOF
1494 exit 1
1495 fi
1496 if test "x$CC" = x ; then
1497 CC=cc
1498 # cat <<EOF 1>&2
1499 # Error: no C compiler: please specify using one of the following:
1500 # 1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1501 # 2) the "-cc=XXX" command-line option
1502 # 3) the "./genmake_local" file
1503 # EOF
1504 # exit 1
1505 fi
1506 if test "x$LINK" = x ; then
1507 LINK=$FC
1508 fi
1509 if test "x$MAKE" = x ; then
1510 MAKE="make"
1511 fi
1512 if test "x$CPP" = x ; then
1513 CPP=cpp
1514 fi
1515 #EH3 === UGLY ===
1516 # The following is an ugly little hack to check for $CPP in /lib/ and
1517 # it should eventually be replaced with a more general function that
1518 # searches a combo of the user's path and a list of "usual suspects"
1519 # to find the correct location for binaries such as $CPP.
1520 for i in " " "/lib/" ; do
1521 echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1522 done
1523 #EH3 === UGLY ===
1524 echo "#define A a" | $CPP > test_cpp 2>&1
1525 RETVAL=$?
1526 if test "x$RETVAL" != x0 ; then
1527 cat <<EOF 1>&2
1528
1529 Error: C pre-processor "$CPP" failed the test case: please specify using:
1530
1531 1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
1532 2) the "./genmake_local" file
1533 3) with the CPP environment variable
1534
1535 EOF
1536 exit 1
1537 else
1538 rm -f test_cpp
1539 fi
1540 look_for_makedepend
1541 if test "x$LN" = x ; then
1542 LN="ln -s"
1543 fi
1544 echo "test" > genmake_test_ln
1545 $LN genmake_test_ln genmake_tlink
1546 RETVAL=$?
1547 if test "x$RETVAL" != x0 ; then
1548 cat <<EOF 1>&2
1549
1550 Error: The command "ln -s" failed -- please specify a working soft-link
1551 command in the optfile.
1552
1553 EOF
1554 exit 1
1555 fi
1556 test -L genmake_tlink > /dev/null 2>&1
1557 RETVAL=$?
1558 if test "x$RETVAL" = x0 ; then
1559 HAVE_TEST_L=t
1560 fi
1561 rm -f genmake_test_ln genmake_tlink
1562
1563 # Check for broken *.F/*.f handling and fix if possible
1564 check_for_broken_Ff
1565
1566 if test ! "x$MPI" = x ; then
1567 echo " Turning on MPI cpp macros"
1568 DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1569 fi
1570
1571 if test ! "x$TS" = x ; then
1572 echo " Turning on timing per timestep"
1573 if test ! "x$FOOLAD" = x ; then
1574 DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1575 else
1576 DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1577 fi
1578 PACKAGES="$PACKAGES showflops"
1579 fi
1580 if test ! "x$PAPIS" = x ; then
1581 echo " Turning on PAPI flop summary per timestep"
1582 echo " Please make sure PAPIINC, PAPILIB are defined"
1583 if test ! "x$FOOLAD" = x ; then
1584 DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1585 else
1586 DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1587 fi
1588 INCLUDES="$INCLUDES $PAPIINC"
1589 LIBS="$LIBS $PAPILIB"
1590 PACKAGES="$PACKAGES showflops"
1591 fi
1592 if test ! "x$PCLS" = x ; then
1593 echo " Turning on PCL counter summary per timestep"
1594 echo " Please make sure PCLINC, PCLLIB are defined"
1595 if test ! "x$FOOLAD" = x ; then
1596 DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1597 else
1598 DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1599 fi
1600 INCLUDES="$INCLUDES $PCLINC"
1601 LIBS="$LIBS $PCLLIB"
1602 PACKAGES="$PACKAGES showflops"
1603 fi
1604 if test ! "x$PAPI" = x ; then
1605 if test ! "x$PAPIS" = x ; then
1606 echo " PAPI performance analysis and flop summary per timestep cannot co-exist!"
1607 echo " Sticking with PAPI flop summary per timestep!"
1608 else
1609 echo " Turning on performance analysis with PAPI"
1610 echo " Please make sure PAPIINC, PAPILIB are defined"
1611 DEFINES="$DEFINES -DUSE_PAPI"
1612 INCLUDES="$INCLUDES $PAPIINC"
1613 LIBS="$LIBS $PAPILIB"
1614 fi
1615 fi
1616 if test ! "x$PCL" = x ; then
1617 if test ! "x$PCLS" = x ; then
1618 echo " PCL performance analysis and flop summary per timestep cannot co-exist!"
1619 echo " Sticking with PCL flop summary per timestep!"
1620 else
1621 echo " Turning on performance analysis with PCL"
1622 echo " Please make sure PCLINC, PCLLIB are defined"
1623 DEFINES="$DEFINES -DUSE_PCL"
1624 INCLUDES="$INCLUDES $PCLINC"
1625 LIBS="$LIBS $PCLLIB"
1626 fi
1627 fi
1628 if test ! "x$HPMT" = x ; then
1629 if test ! "x$PAPI" = x ; then
1630 echo " PAPI and the HPM Toolkit cannot co-exist!"
1631 echo " Sticking with PAPI!"
1632 else if test ! "x$PCL" = x ; then
1633 echo " PCL and the HPM Toolkit cannot co-exist!"
1634 echo " Sticking with PCL!"
1635 else
1636 echo " Turning on performance analysis with the HPM Toolkit"
1637 echo " Please make sure HPMTINC, HPMTLIB are defined"
1638 DEFINES="$DEFINES -DUSE_LIBHPM"
1639 INCLUDES="$INCLUDES $HPMTINC"
1640 LIBS="$LIBS $HPMTLIB"
1641 fi
1642 fi
1643 fi
1644 if test ! "x$GSL" = x ; then
1645 echo " Turning on use of GSL to control floating point calculations"
1646 echo " Please make sure GSLINC, GSLLIB are defined"
1647 DEFINES="$DEFINES -DUSE_GSL_IEEE"
1648 INCLUDES="$INCLUDES $GSLINC"
1649 LIBS="$LIBS $GSLLIB"
1650 fi
1651 #- if USE_EXTENDED_SRC is set, add EXTENDED_SRC_FLAG to FFLAGS :
1652 if test ! "x$USE_EXTENDED_SRC" = x ; then
1653 FFLAGS="$FFLAGS $EXTENDED_SRC_FLAG"
1654 F90FIXEDFORMAT="$F90FIXEDFORMAT $EXTENDED_SRC_FLAG"
1655 fi
1656
1657 printf "\n=== Checking system libraries ===\n"
1658 printf " Do we have the system() command using $FC... "
1659 cat > genmake_tcomp.$FS <<EOF
1660 program hello
1661 call system('echo hi')
1662 end
1663 EOF
1664 $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1665 RETVAL=$?
1666 if test "x$RETVAL" = x0 ; then
1667 HAVE_SYSTEM=t
1668 DEFINES="$DEFINES -DHAVE_SYSTEM"
1669 echo "yes"
1670 else
1671 HAVE_SYSTEM=
1672 echo "no"
1673 fi
1674 rm -f genmake_tcomp*
1675
1676 printf " Do we have the fdate() command using $FC... "
1677 cat > genmake_tcomp.$FS <<EOF
1678 program hello
1679 CHARACTER*(128) string
1680 string = ' '
1681 call fdate( string )
1682 print *, string
1683 end
1684 EOF
1685 $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1686 RETVAL=$?
1687 if test "x$RETVAL" = x0 ; then
1688 HAVE_FDATE=t
1689 DEFINES="$DEFINES -DHAVE_FDATE"
1690 echo "yes"
1691 else
1692 HAVE_FDATE=
1693 echo "no"
1694 fi
1695 rm -f genmake_tcomp*
1696
1697 printf " Do we have the etime() command using $FC... "
1698 cat > genmake_tcomp.$FS <<EOF
1699 program hello
1700 REAL*4 ACTUAL, TARRAY(2)
1701 EXTERNAL ETIME
1702 REAL*4 ETIME
1703 actual = etime( tarray )
1704 print *, tarray
1705 end
1706 EOF
1707 $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1708 RETVAL=$?
1709 if test "x$RETVAL" = x0 ; then
1710 HAVE_ETIME=t
1711 DEFINES="$DEFINES -DHAVE_ETIME"
1712 echo "yes"
1713 else
1714 HAVE_ETIME=
1715 echo "no"
1716 fi
1717 rm -f genmake_tcomp*
1718
1719 printf " Can we call simple C routines (here, \"cloc()\") using $FC... "
1720 check_HAVE_CLOC
1721 if test "x$HAVE_CLOC" != x ; then
1722 echo "yes"
1723 else
1724 echo "no"
1725 if test "x$EMBED_SRC" = xt ; then
1726 echo " WARNING: you requested file embedding but it has"
1727 echo " been disabled since C code cannot be called"
1728 EMBED_SRC=
1729 fi
1730 fi
1731 rm -f genmake_t*
1732
1733 printf " Can we unlimit the stack size using $FC... "
1734 check_HAVE_SETRLSTK
1735 if test "x$HAVE_SETRLSTK" = xt ; then
1736 echo "yes"
1737 else
1738 echo "no"
1739 fi
1740 rm -f genmake_t*
1741
1742 printf " Can we register a signal handler using $FC... "
1743 check_HAVE_SIGREG
1744 if test "x$HAVE_SIGREG" = xt ; then
1745 echo "yes"
1746 else
1747 echo "no"
1748 fi
1749 rm -f genmake_t*
1750
1751 printf " Can we use stat() through C calls... "
1752 check_HAVE_STAT
1753 if test "x$HAVE_STAT" != x ; then
1754 echo "yes"
1755 else
1756 echo "no"
1757 fi
1758 rm -f genmake_t*
1759
1760 printf " Can we create NetCDF-enabled binaries... "
1761 check_netcdf_libs
1762 if test "x$HAVE_NETCDF" != x ; then
1763 echo "yes"
1764 else
1765 echo "no"
1766 fi
1767 DEFINES="$DEFINES $IGNORE_TIME"
1768
1769 if test "x$EMBED_SRC" = xt ; then
1770 build_embed_encode
1771 fi
1772 if test "x$EMBED_SRC" = xt ; then
1773 ENABLE="$ENABLE embed_files"
1774 fi
1775
1776
1777 printf "\n=== Setting defaults ===\n"
1778 printf " Adding MODS directories: "
1779 MPI_LNKF=
1780 for d in $MODS ; do
1781 if test ! -d $d ; then
1782 echo
1783 echo "Error: MODS directory \"$d\" not found!"
1784 exit 1
1785 else
1786 printf "$d "
1787 SOURCEDIRS="$SOURCEDIRS $d"
1788 INCLUDEDIRS="$INCLUDEDIRS $d"
1789 #-------------------------------------------------------
1790 # Put special links so that MPI specific files are used
1791 MPI_FILES=`(cd $d ; find . -name "*_mpi" -print)`
1792 for i in $MPI_FILES ; do
1793 ii=`echo $i | sed 's:^\./::'`
1794 name=`echo $ii | sed 's:_mpi::' `
1795 if test "x$MPI" = x ; then
1796 # NO: We undo an _mpi symbolically linked file
1797 if test -L $name ; then
1798 cmp $name "$d/$ii" > /dev/null 2>&1
1799 RETVAL=$?
1800 if test "x$RETVAL" = x0 ; then
1801 printf "Un-linking $name ; "
1802 rm -f $name
1803 fi
1804 fi
1805 else
1806 # YES: We symbolically link this file (with conditions if already there)
1807 if test -L $name ; then
1808 cmp $d/$ii $name > /dev/null 2>&1
1809 RETVAL=$?
1810 xx=`echo $MPI_LNKF | grep -c $name`
1811 if test "x$RETVAL" != x0 -a $xx == 0 ; then
1812 # remove sym-link if different and has not just been linked
1813 printf "Un-link + "
1814 rm -f $name
1815 fi
1816 if test "x$RETVAL" = x0 ; then
1817 # if identical, keep sym-link and keep record of it
1818 MPI_LNKF="$MPI_LNKF $name"
1819 fi
1820 fi
1821 if ! test -f $name ; then
1822 # make sym-link and keep record of it
1823 printf "Linking $ii to $name ; "
1824 ln -s $d/$ii $name
1825 MPI_LNKF="$MPI_LNKF $name"
1826 fi
1827 fi
1828 done
1829 #-------------------------------------------------------
1830 fi
1831 done
1832 echo
1833
1834 if test "x${PLATFORM}" = x ; then
1835 PLATFORM=$p_PLATFORM
1836 fi
1837
1838 if test "x${EXEDIR}" = x ; then
1839 tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1840 if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1841 EXEDIR=../exe
1842 else
1843 EXEDIR=.
1844 fi
1845 fi
1846 if test ! -d ${EXEDIR} ; then
1847 echo "Error: the specified EXEDIR (\"$EXEDIR\") does not exist!"
1848 exit 1
1849 fi
1850
1851 if test "x${TOOLSDIR}" = x ; then
1852 TOOLSDIR="$ROOTDIR/tools"
1853 fi
1854 if test ! -d ${TOOLSDIR} ; then
1855 echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1856 exit 1
1857 fi
1858 if test "x$S64" = x ; then
1859 echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.sh > /dev/null 2>&1
1860 RETVAL=$?
1861 if test "x${RETVAL}" = x0 ; then
1862 S64='$(TOOLSDIR)/set64bitConst.sh'
1863 else
1864 echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.csh > /dev/null 2>&1
1865 RETVAL=$?
1866 if test "x${RETVAL}" = x0 ; then
1867 S64='$(TOOLSDIR)/set64bitConst.csh'
1868 else
1869 cat <<EOF
1870
1871 ERROR: neither of the two default scripts:
1872
1873 ${TOOLSDIR}/set64bitConst.sh
1874 ${TOOLSDIR}/set64bitConst.csh
1875
1876 are working so please check paths or specify (with \$S64) a
1877 working version of this script.
1878
1879 EOF
1880 exit 1
1881 fi
1882 fi
1883 fi
1884 THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1885
1886 EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1887
1888 # We have a special set of source files in eesupp/src which are
1889 # generated from some template source files. We'll make them first so
1890 # they appear as regular source code
1891 if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
1892 echo " Making source files in eesupp from templates"
1893 ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
1894 RETVAL=$?
1895 if test "x${RETVAL}" = x0 ; then
1896 rm -f make_eesupp.errors
1897 else
1898 echo "Error: problem encountered while building source files in eesupp:"
1899 cat make_eesupp.errors 1>&2
1900 exit 1
1901 fi
1902 fi
1903
1904 #same for pkg/exch2 and pkg/regrid
1905 for pdir in exch2 regrid ; do
1906 if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1907 echo " Making source files in pkg/${pdir} from templates"
1908 ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1909 RETVAL=$?
1910 if test "x${RETVAL}" = x0 ; then
1911 rm -f make_${pdir}.errors
1912 else
1913 echo "Error: problem encountered while building source files in pkg/${pdir}:"
1914 cat make_${pdir}.errors 1>&2
1915 exit 1
1916 fi
1917 fi
1918 done
1919
1920 printf "\n=== Determining package settings ===\n"
1921 if test "x${PDEPEND}" = x ; then
1922 tmp=$ROOTDIR"/pkg/pkg_depend"
1923 if test -r $tmp ; then
1924 PDEPEND=$tmp
1925 else
1926 echo "Warning: No package dependency information was specified."
1927 echo " Please check that ROOTDIR/pkg/pkg_depend exists."
1928 fi
1929 else
1930 if test ! -r ${PDEPEND} ; then
1931 echo "Error: can't read package dependency info from PDEPEND=\"$PDEPEND\""
1932 exit 1
1933 fi
1934 fi
1935 echo " getting package dependency info from $PDEPEND"
1936 # Strip the comments and then convert the dependency file into
1937 # two arrays: PNAME, DNAME
1938 cat $PDEPEND | sed -e 's/#.*$//g' \
1939 | $AWK 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
1940 > ./.pd_tmp
1941 RETVAL=$?
1942 if test ! "x${RETVAL}" = x0 ; then
1943 echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1944 exit 1
1945 fi
1946 . ./.pd_tmp
1947 rm -f ./.pd_tmp
1948
1949 # Search for default packages. Note that a "$ROOTDIR/pkg/pkg_groups"
1950 # file should eventually be added so that, for convenience, one can
1951 # specify groups of packages using names like "ocean" and "atmosphere".
1952 echo " checking default package list: "
1953 if test "x${PDEFAULT}" = x ; then
1954 for i in "." $MODS ; do
1955 if test -r $i"/packages.conf" ; then
1956 PDEFAULT=$i"/packages.conf"
1957 break
1958 fi
1959 done
1960 fi
1961 if test "x${PDEFAULT}" = x ; then
1962 PDEFAULT="$ROOTDIR/pkg/pkg_default"
1963 fi
1964 if test "x${PDEFAULT}" = xNONE ; then
1965 echo " default packages file disabled"
1966 else
1967 if test ! -r $PDEFAULT ; then
1968 echo "Warning: can't read default packages from PDEFAULT=\"$PDEFAULT\""
1969 else
1970 echo " using PDEFAULT=\"$PDEFAULT\""
1971 # Strip the comments and add all the names
1972 def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1973 RETVAL=$?
1974 if test "x${RETVAL}" != x0 ; then
1975 printf "Error: can't parse default package list "
1976 echo "-- please check PDEFAULT=\"$PDEFAULT\""
1977 exit 1
1978 fi
1979 for i in $def ; do
1980 PACKAGES="$PACKAGES $i"
1981 done
1982 echo " before group expansion packages are: $PACKAGES"
1983 RET=1
1984 while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1985 echo " after group expansion packages are: $PACKAGES"
1986 fi
1987 fi
1988
1989 echo " applying DISABLE settings"
1990 for i in $PACKAGES ; do
1991 echo $i >> ./.tmp_pack
1992 done
1993 for i in `grep "-" ./.tmp_pack` ; do
1994 j=`echo $i | sed 's/[-]//'`
1995 DISABLE="$DISABLE $j"
1996 done
1997 pack=
1998 for p in $PACKAGES ; do
1999 addit="t"
2000 for d in $DISABLE ; do
2001 if test "x$p" = "x$d" ; then
2002 addit="f"
2003 fi
2004 done
2005 if test "x$addit" = xt ; then
2006 pack="$pack $p"
2007 fi
2008 done
2009 PACKAGES="$pack"
2010 echo " applying ENABLE settings"
2011 echo "" > ./.tmp_pack
2012 PACKAGES="$PACKAGES $ENABLE"
2013 # Test if each explicitly referenced package exists
2014 for i in $PACKAGES ; do
2015 j=`echo $i | sed 's/[-+]//'`
2016 if test ! -d "$ROOTDIR/pkg/$j" ; then
2017 echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
2018 exit 1
2019 fi
2020 echo $i >> ./.tmp_pack
2021 done
2022 PACKAGES=
2023 for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
2024 PACKAGES="$PACKAGES $i"
2025 done
2026 rm -f ./.tmp_pack
2027 echo " packages are: $PACKAGES"
2028
2029 # Check for package MNC: if NetCDF is available, then build the MNC
2030 # template files ; otherwise, delete mnc from the list of packages.
2031 echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
2032 RETVAL=$?
2033 if test "x$RETVAL" = x0 ; then
2034 if test "x$HAVE_NETCDF" != xt ; then
2035 cat <<EOF
2036
2037 *********************************************************************
2038 WARNING: the "mnc" package was enabled but tests failed to compile
2039 NetCDF applications. Please check that:
2040
2041 1) NetCDF is correctly installed for this compiler and
2042 2) the LIBS variable (within the "optfile") specifies the correct
2043 NetCDF library to link against.
2044
2045 Due to this failure, the "mnc" package is now DISABLED.
2046 *********************************************************************
2047
2048 EOF
2049 PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
2050 DISABLE="$DISABLE mnc"
2051 else
2052 ( cd $ROOTDIR"/pkg/mnc" && $MAKE testclean && $MAKE templates ) > make_mnc.errors 2>&1
2053 RETVAL=$?
2054 if test "x${RETVAL}" = x0 ; then
2055 rm -f make_mnc.errors
2056 else
2057 echo "Error: problem encountered while building source files in pkg/mnc:"
2058 cat make_mnc.errors 1>&2
2059 exit 1
2060 fi
2061 fi
2062 fi
2063
2064 # Check for package PROFILES: if NetCDF is not available,
2065 # then delete profiles from the list of available packages.
2066 echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2067 RETVAL=$?
2068 if test "x$RETVAL" = x0 ; then
2069 if test "x$HAVE_NETCDF" != xt ; then
2070 cat <<EOF
2071
2072 *********************************************************************
2073 WARNING: the "profiles" package was enabled but tests failed to
2074 compile NetCDF applications. Please check that:
2075
2076 1) NetCDF is correctly installed for this compiler and
2077 2) the LIBS variable (within the "optfile") specifies the correct
2078 NetCDF library to link against.
2079
2080 Due to this failure, the "profiles" package is now DISABLED.
2081 *********************************************************************
2082
2083 EOF
2084 PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2085 DISABLE="$DISABLE profiles"
2086 fi
2087 fi
2088
2089 echo " applying package dependency rules"
2090 ck=
2091 while test "x$ck" != xtt ; do
2092 i=0
2093 # rtot=${#PNAME[@]}
2094 rtot=$nname
2095 while test $i -le $rtot ; do
2096
2097 # Is $pname in the current $PACKAGES list?
2098 # pname=${PNAME[$i]}
2099 tmp="pname=\"\$PNAME_$i\""
2100 eval $tmp
2101 pin="f"
2102 for p in $PACKAGES ; do
2103 if test "x$p" = "x$pname" ; then
2104 pin="t"
2105 fi
2106 done
2107
2108 # Is the DNAME entry a (+) or (-) rule ?
2109 tmp="dname=\"\$DNAME_$i\""
2110 eval $tmp
2111 plus="-"
2112 echo $dname | grep '^+' > /dev/null 2>&1
2113 RETVAL=$?
2114 if test "x$RETVAL" = x0 ; then
2115 plus="+"
2116 fi
2117
2118 # Is $dname in the current $PACKAGES list?
2119 dname=`echo $dname | sed -e 's/^[+-]//'`
2120 din="f"
2121 for p in $PACKAGES ; do
2122 if test "x$p" = "x$dname" ; then
2123 din="t"
2124 fi
2125 done
2126
2127 # Do we need to add $dname according to the dependency rules?
2128 if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2129 #echo " " $pname ": need to add :" $dname
2130 in_dis="f"
2131 for dis in $DISABLE ; do
2132 if test "x$dis" = "x$dname" ; then
2133 in_dis="t"
2134 fi
2135 done
2136 if test "x$in_dis" = xt ; then
2137 echo "Error: can't satisfy package dependencies:"
2138 echo " \"$dname\" is required by the dependency rules"
2139 echo " but is disallowed by the DISABLE settings"
2140 exit 1
2141 else
2142 PACKAGES="$PACKAGES $dname"
2143 ck=
2144 fi
2145 fi
2146
2147 # Do we need to get rid of $dname according to the dependency rules?
2148 if test "x$pin" = xt -a "x$plus" = "x-" -a "x$din" = xt; then
2149 echo "Error: can't satisfy package dependencies:"
2150 echo " \"$pname\" was requested but is disallowed by"
2151 echo " the dependency rules for \"$dname\""
2152 exit 1
2153 fi
2154 i=`echo "$i + 1" | bc -l`
2155 #i=$(( $i + 1 ))
2156 done
2157 ck=$ck"t"
2158 done
2159 echo " packages are: $PACKAGES"
2160 for i in $PACKAGES ; do
2161 adr="$ROOTDIR/pkg/$i"
2162 if test -d $adr ; then
2163 SOURCEDIRS="$SOURCEDIRS $adr"
2164 INCLUDEDIRS="$INCLUDEDIRS $adr"
2165 if test "x$i" = xautodiff ; then
2166 AUTODIFF_PKG_USED=t
2167 fi
2168 else
2169 echo "Error: the directory \"$adr\" for package $i doesn't exist"
2170 exit 1
2171 fi
2172 done
2173
2174 # Create a list of #define and #undef to enable/disable packages
2175 PACKAGES_DOT_H=PACKAGES_CONFIG.h
2176 # The following UGLY HACK sets multiple "#undef"s and it needs to go
2177 # away. On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
2178 # file would eventually be split up so that all package-related #define
2179 # statements could be separated and handled only by genmake.
2180 names=`ls -1 "$ROOTDIR/pkg"`
2181 all_pack=
2182 DISABLED_PACKAGES=
2183 for n in $names ; do
2184 if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
2185 has_pack="f"
2186 for pack in $PACKAGES ; do
2187 if test "x$pack" = "x$n" ; then
2188 has_pack="t"
2189 break
2190 fi
2191 done
2192 if test "x$has_pack" = xf ; then
2193 undef=`echo "ALLOW_$n" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2194 DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
2195 fi
2196 fi
2197 done
2198 ENABLED_PACKAGES=
2199 for i in $PACKAGES ; do
2200 def=`echo "ALLOW_$i" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2201 ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
2202 #eh3 DEFINES="$DEFINES -D$def"
2203
2204 #EH3 WARNING : This is an UGLY HACK that needs to be removed!!!
2205 case $i in
2206 aim_v23)
2207 ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
2208 echo "Warning: ALLOW_AIM is set to enable aim_v23."
2209 ;;
2210 esac
2211 #EH3 WARNING : This is an UGLY HACK that needs to be removed!!!
2212
2213 done
2214
2215 echo " Adding STANDARDDIRS"
2216 BUILDDIR=${BUILDDIR:-.}
2217 if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
2218 STANDARDDIRS="eesupp model"
2219 fi
2220 if test "x$STANDARDDIRS" != x ; then
2221 for d in $STANDARDDIRS ; do
2222 adr="$ROOTDIR/$d/src"
2223 if test ! -d $adr ; then
2224 echo "Error: directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
2225 echo " is correct and that you correctly specified the STANDARDDIRS option"
2226 exit 1
2227 else
2228 SOURCEDIRS="$SOURCEDIRS $adr"
2229 fi
2230 adr="$ROOTDIR/$d/inc"
2231 if test ! -d $adr ; then
2232 echo "Error: directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
2233 echo " is correct and that you correctly specified the STANDARDDIRS option"
2234 exit 1
2235 else
2236 INCLUDEDIRS="$INCLUDEDIRS $adr"
2237 fi
2238 done
2239 fi
2240
2241 echo " Searching for *OPTIONS.h files in order to warn about the presence"
2242 echo " of \"#define \"-type statements that are no longer allowed:"
2243 CPP_OPTIONS=
2244 CPP_EEOPTIONS=
2245 spaths=". $INCLUDEDIRS"
2246 names=`ls -1 "$ROOTDIR/pkg"`
2247 for i in $spaths ; do
2248 try="$i/CPP_OPTIONS.h"
2249 if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
2250 echo " found CPP_OPTIONS=\"$try\""
2251 CPP_OPTIONS="$try"
2252 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
2253 for n in $names ; do
2254 test_for_package_in_cpp_options $CPP_OPTIONS $n
2255 done
2256 fi
2257 try="$i/CPP_EEOPTIONS.h"
2258 if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
2259 echo " found CPP_EEOPTIONS=\"$try\""
2260 # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
2261 #**** not yet enabled ****
2262 # test_for_mpi_in_cpp_eeoptions $try
2263 #**** not yet enabled ****
2264 CPP_EEOPTIONS="$try"
2265 fi
2266 done
2267 if test "x$CPP_OPTIONS" = x ; then
2268 echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
2269 exit 1
2270 fi
2271
2272 # Here, we build the list of files to be "run through" the adjoint
2273 # compiler.
2274 if test -f ./adSrcFiles.tmp ; then
2275 rm -f ./adSrcFiles.tmp
2276 fi
2277 echo " Creating the list of files for the adjoint compiler."
2278 for i in $SOURCEDIRS ; do
2279 list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
2280 for j in $list_files ; do
2281 cat $i/$j >> adSrcFiles.tmp
2282 done
2283 done
2284 if test ! "x"$FS = "x.f" ; then
2285 cat adSrcFiles.tmp | sed -e "s/\.f/.$FS/g" > adSrcFiles.tmp_f
2286 mv -f adSrcFiles.tmp_f adSrcFiles.tmp
2287 fi
2288
2289 echo
2290 echo "=== Creating the Makefile ==="
2291 echo " setting INCLUDES"
2292 for i in $INCLUDEDIRS ; do
2293 if test ! -d $i ; then
2294 echo "Warning: can't find INCLUDEDIRS=\"$i\""
2295 fi
2296 done
2297
2298 if test ! "x$DIVA" = x ; then
2299 echo " Creating the pseudo-MPI include directory"
2300 INCLUDES="-I./mpi_headers $INCLUDES"
2301 rm -rf ./mpi_headers
2302 mkdir -p ./mpi_headers
2303
2304 if test "x$MPIINCLUDEDIR" = x ; then
2305 if test "x$MPIHOME" = x ; then
2306 MPIHOME='/usr'
2307 fi
2308 MPIINCLUDEDIR='$MPIHOME/include'
2309 fi
2310
2311 if test -r $MPIINCLUDEDIR/mpif.h ; then
2312 for i in $MPI_HEADER_FILES; do
2313 cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2314 done
2315
2316 perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2317 else
2318 echo " We cannot create a copy of mpif.h!"
2319 # exit -1
2320 fi
2321 fi
2322
2323 echo " Determining the list of source and include files"
2324 rm -rf .links.tmp
2325 mkdir .links.tmp
2326 touch .links.tmp/foo
2327 if test ! -r ".links.tmp/foo" ; then
2328 echo
2329 echo "ERROR : something is wrong with your directory permissions or"
2330 echo " your user file-creation mask (\"umask\") since creating a"
2331 echo " sub-dir, touch-ing a file within it, and then reading it is"
2332 echo " not working. Please try setting your umask to something"
2333 echo " sane such as:"
2334 echo
2335 echo " umask 0002"
2336 echo
2337 echo " and please verify that you have the proper permissions for"
2338 echo " creating sub-directories and then reading files created"
2339 echo " within them."
2340 echo
2341 exit 1
2342 fi
2343 rm -f .links.tmp/foo
2344
2345 if test "x$OPENAD" != x ; then
2346 OAD_DONT_COMPILE="/dev/null"
2347 OAD_DONT_TRANSFORM="/dev/null"
2348 OAD_KEEP_ORIGINAL="/dev/null"
2349 OAD_CB2M_FILES="/dev/null"
2350 echo " looking for dontCompile file: "
2351 for i in "." $MODS ; do
2352 if test -r $i"/dontCompile" ; then
2353 OAD_DONT_COMPILE=$i"/dontCompile"
2354 echo " found $OAD_DONT_COMPILE"
2355 break
2356 fi
2357 done
2358 echo " looking for dontTransform file: "
2359 for i in "." $MODS ; do
2360 if test -r $i"/dontTransform" ; then
2361 OAD_DONT_TRANSFORM=$i"/dontTransform"
2362 echo " found $OAD_DONT_TRANSFORM"
2363 break
2364 fi
2365 done
2366 echo " looking for keepOriginal file: "
2367 for i in "." $MODS ; do
2368 if test -r $i"/keepOriginal" ; then
2369 OAD_KEEP_ORIGINAL=$i"/keepOriginal"
2370 echo " found $OAD_KEEP_ORIGINAL"
2371 break
2372 fi
2373 done
2374 echo " looking for cb2mFiles: "
2375 for i in "." $MODS ; do
2376 if test -r $i"/cb2mFiles" ; then
2377 OAD_CB2M_FILES=$i"/cb2mFiles"
2378 echo " found $OAD_CB2M_FILES"
2379 break
2380 fi
2381 done
2382 echo " OpenAD exceptions: "
2383 fi
2384
2385 echo "# This section creates symbolic links" > srclinks.tmp
2386 echo "" >> srclinks.tmp
2387 printf 'F77_SRC_FILES = ' > F77srclist.tmp
2388 printf 'NON_AD_F77_SRC_FILES = ' > nonADF77srclist.tmp
2389 printf 'C_SRC_FILES = ' > csrclist.tmp
2390 printf 'F90_SRC_FILES = ' > F90srclist.tmp
2391 printf 'H_SRC_FILES = ' > hsrclist.tmp
2392 printf 'AD_FLOW_FILES = ' > ad_flow_files.tmp
2393 alldirs="$SOURCEDIRS $INCLUDEDIRS ."
2394 for d in $alldirs ; do
2395 deplist=
2396 sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
2397 sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
2398 if test "x$OPENAD" != x ; then
2399 sfiles=`( echo $sfiles | grep -v _cb2m\. )`
2400 fi
2401 for sf in $sfiles ; do
2402 if test ! -r ".links.tmp/$sf" ; then
2403 if test -f "$d/$sf" ; then
2404 ignore_f=f
2405 case $d/$sf in
2406 ./$PACKAGES_DOT_H)
2407 ignore_f=t
2408 ;;
2409 ./AD_CONFIG.h)
2410 ignore_f=t
2411 ;;
2412 ./FC_NAMEMANGLE.h)
2413 ignore_f=t
2414 ;;
2415 ./BUILD_INFO.h)
2416 ignore_f=t
2417 ;;
2418 ./EMBEDDED_FILES.h)
2419 ignore_f=t
2420 ;;
2421 *)
2422 # For the local directory *ONLY*,
2423 # ignore all soft-links
2424 if test "x$HAVE_TEST_L" = xt -a "x$d" = x. -a -L $sf ; then
2425 ignore_f=t
2426 else
2427 touch .links.tmp/$sf
2428 deplist="$deplist $sf"
2429 fi
2430 ;;
2431 esac
2432 if test "x$ignore_f" = xf ; then
2433 extn=`echo $sf | $AWK -F. '{print $NF}'`
2434 case $extn in
2435 F)
2436 echo " \\" >> F77srclist.tmp
2437 printf " $sf" >> F77srclist.tmp
2438 if test "x$OPENAD" != x ; then
2439 basename=${sf%%.F}
2440 isAD=`egrep ^$basename.f'[ ]*' adSrcFiles.tmp`
2441 if test -z "$isAD" ; then
2442 toBeIgnored=`egrep ^$basename'[ ]*' ${OAD_DONT_COMPILE}`
2443 if test -z "$toBeIgnored" ; then
2444 echo " \\" >> nonADF77srclist.tmp
2445 printf " $sf" >> nonADF77srclist.tmp
2446 else
2447 echo " not to be compiled : $sf"
2448 fi
2449 else # file is initially listed as an AD file we want to exclude it
2450 # or we want to retain the untransformed version
2451 notToBeTransformed=`egrep ^$basename'[ ]*' ${OAD_DONT_TRANSFORM}`
2452 untransformedVersionToBeKept=`egrep ^$basename'[ ]*' ${OAD_KEEP_ORIGINAL}`
2453 if test -n "$notToBeTransformed"; then
2454 echo " not to be transformed: $sf"
2455 fi
2456 if test -n "$untransformedVersionToBeKept" ; then
2457 echo " original to be kept : $sf"
2458 fi
2459 if test -n "$notToBeTransformed" -o -n "$untransformedVersionToBeKept" ; then
2460 echo " \\" >> nonADF77srclist.tmp
2461 printf " $sf" >> nonADF77srclist.tmp
2462 fi
2463 fi
2464 fi
2465 ;;
2466 F90)
2467 echo " \\" >> F90srclist.tmp
2468 printf " $sf" >> F90srclist.tmp
2469 ;;
2470 c)
2471 echo " \\" >> csrclist.tmp
2472 printf " $sf" >> csrclist.tmp
2473 ;;
2474 h)
2475 echo " \\" >> hsrclist.tmp
2476 printf " $sf" >> hsrclist.tmp
2477 ;;
2478 flow)
2479 echo " \\" >> ad_flow_files.tmp
2480 printf " $sf" >> ad_flow_files.tmp
2481 ;;
2482 esac
2483 fi
2484 fi
2485 fi
2486 done
2487 if test "x$deplist" != x ; then
2488 if test "$d" != "." ; then
2489 echo "" >> srclinks.tmp
2490 echo "# These files are linked from $d" >> srclinks.tmp
2491 echo "$deplist :" >> srclinks.tmp
2492 # We need to make sure that the link isn't already there.
2493 # This may happen when make thinks that a header file has to be "remade"
2494 # because a module it depends on has changed. In this case we do nothing.
2495 printf "\tif [ ! -L \$@ ]; then \$(LN) %s/\$@ \$@; fi\n" $d >> srclinks.tmp
2496 fi
2497 fi
2498 done
2499 rm -rf .links.tmp
2500 echo "" >> F77srclist.tmp
2501 echo "" >> nonADF77srclist.tmp
2502 echo "" >> csrclist.tmp
2503 echo "" >> F90srclist.tmp
2504 echo "" >> hsrclist.tmp
2505 echo "" >> ad_flow_files.tmp
2506
2507 if test -f $MAKEFILE ; then
2508 mv -f $MAKEFILE "$MAKEFILE.bak"
2509 fi
2510 echo " Writing makefile: $MAKEFILE"
2511 echo "# Multithreaded + multi-processing makefile for:" > $MAKEFILE
2512 echo "# $MACHINE" >> $MAKEFILE
2513 echo "# This makefile was generated automatically on" >> $MAKEFILE
2514 echo "# $THISDATE" >> $MAKEFILE
2515 echo "# by the command:" >> $MAKEFILE
2516 echo "# $0 $G2ARGS" >> $MAKEFILE
2517 echo "# executed by:" >> $MAKEFILE
2518 echo "# ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
2519
2520 EXE_AD=$EXECUTABLE"_ad"
2521 EXE_FTL=$EXECUTABLE"_ftl"
2522 EXE_SVD=$EXECUTABLE"_svd"
2523
2524 cat >>$MAKEFILE <<EOF
2525 #
2526 # OPTFILE="$OPTFILE"
2527 #
2528 # BUILDDIR : Directory where object files are written
2529 # SOURCEDIRS : Directories containing the source (.F) files
2530 # INCLUDEDIRS : Directories containing the header-source (.h) files
2531 # EXEDIR : Directory where executable that is generated is written
2532 # EXECUTABLE : Full path of executable binary
2533 #
2534 # CPP : C-preprocessor command
2535 # INCLUDES : Directories searched for header files
2536 # DEFINES : Macro definitions for CPP
2537 # MAKEDEPEND : Dependency generator
2538 # KPP : Special preprocessor command (specific to platform)
2539 # KFLAGS : Flags for KPP
2540 # FC : Fortran compiler command
2541 # FFLAGS : Configuration/debugging options for FC
2542 # FOPTIM : Optimization options for FC
2543 # LINK : Command for link editor program
2544 # LIBS : Library flags /or/ additional optimization/debugging flags
2545
2546 ROOTDIR = ${ROOTDIR}
2547 BUILDDIR = ${BUILDDIR}
2548 SOURCEDIRS = ${SOURCEDIRS}
2549 INCLUDEDIRS = ${INCLUDEDIRS}
2550 EXEDIR = ${EXEDIR}
2551 EXECUTABLE = \$(EXEDIR)/${EXECUTABLE}
2552 TOOLSDIR = ${TOOLSDIR}
2553
2554 #eh3 new defines for the adjoint work
2555 AUTODIFF = ${ROOTDIR}/pkg/autodiff
2556 EXE_AD = ${EXE_AD}
2557 EXE_FTL = ${EXE_FTL}
2558 EXE_SVD = ${EXE_SVD}
2559
2560 ENABLED_PACKAGES = ${ENABLED_PACKAGES}
2561 DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2562
2563 # These files are created by Makefile
2564 SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
2565 EOF
2566
2567 if test "x$EMBED_SRC" = xt ; then
2568 echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2569 else
2570 echo "EMBEDDED_FILES = " >>$MAKEFILE
2571 fi
2572
2573 # Note: figure out some way to add Hyades JAM libraries here
2574 cat >>$MAKEFILE <<EOF
2575 # Unix ln (link)
2576 LN = ${LN}
2577 # C preprocessor
2578 CPP = cat \$< | ${S64} | ${CPP}
2579 # Dependency generator
2580 MAKEDEPEND = ${MAKEDEPEND}
2581 # Special preprocessor (KAP on DECs, FPP on Crays)
2582 KPP = ${KPP}
2583 # Fortran compiler
2584 FC = ${FC}
2585 # Fortran compiler
2586 F90C = ${F90C}
2587 # C compiler
2588 CC = ${CC}
2589 # Link editor
2590 LINK = ${LINK} ${LDADD}
2591
2592 # Defines for CPP
2593 DEFINES = ${DEFINES}
2594 # Includes for CPP
2595 INCLUDES = ${INCLUDES}
2596 # Flags for KPP
2597 KFLAGS1 = ${KFLAGS1}
2598 KFLAGS2 = ${KFLAGS2}
2599 # Optim./debug for FC
2600 FFLAGS = ${FFLAGS} ${FEXTRAFLAGS}
2601 FOPTIM = ${FOPTIM}
2602 # Optim./debug for FC
2603 F90FLAGS = ${F90FLAGS}
2604 F90OPTIM = ${F90OPTIM}
2605 F90FIXEDFORMAT = ${F90FIXEDFORMAT}
2606 # Flags for CC
2607 CFLAGS = ${CFLAGS}
2608 # Files that should not be optimized
2609 NOOPTFILES = ${NOOPTFILES}
2610 NOOPTFLAGS = ${NOOPTFLAGS}
2611 # Flags and libraries needed for linking
2612 LIBS = ${LIBS}
2613 # Name of the Mekfile
2614 MAKEFILE=${MAKEFILE}
2615
2616 EOF
2617
2618 cat F77srclist.tmp >> $MAKEFILE
2619 cat nonADF77srclist.tmp >> $MAKEFILE
2620 cat csrclist.tmp >> $MAKEFILE
2621 cat F90srclist.tmp >> $MAKEFILE
2622 cat hsrclist.tmp >> $MAKEFILE
2623 cat ad_flow_files.tmp >> $MAKEFILE
2624
2625 rm -f F77srclist.tmp nonADF77srclist.tmp csrclist.tmp F90srclist.tmp hsrclist.tmp ad_flow_files.tmp
2626
2627 echo >> $MAKEFILE
2628
2629 # add definitions for preprocessed sources
2630 # and note that not all systems allow case sensitive extensions
2631 # hence the $FS and $FS90 here.
2632 # for fixed format f90 files we use ff90 or FF90 resp
2633 # but these are not expected to be the original source files
2634
2635 echo 'F77_PP_SRC_FILES = $(F77_SRC_FILES:.F=.'$FS')' >> $MAKEFILE
2636 echo 'F90_PP_SRC_FILES = $(F90_SRC_FILES:.F90=.'$FS90')' >> $MAKEFILE
2637 echo 'OBJFILES= $(F77_SRC_FILES:.F=.o) $(C_SRC_FILES:.c=.o) $(F90_SRC_FILES:.F90=.o)' >> $MAKEFILE
2638 echo 'FLOFILES = $(AD_FLOW_FILES:.flow=.flowdir)' >> $MAKEFILE
2639 echo >> $MAKEFILE
2640 echo '.SUFFIXES:' >> $MAKEFILE
2641 echo '.SUFFIXES: .o .'$FS' .p .F .c .f'$FS90' .'$FS90' .FF90 .F90 .flowdir .flow' >> $MAKEFILE
2642
2643 cat >>$MAKEFILE <<EOF
2644
2645 all: \$(EXECUTABLE)
2646 \$(EXECUTABLE): \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2647 @echo Creating \$@ ...
2648 \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2649 depend:
2650 @make links
2651 \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(F77_SRC_FILES)
2652 \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2653 -rm -f makedepend.out
2654
2655 lib: libmitgcmuv.a
2656
2657 libmitgcmuv.a: \$(OBJFILES)
2658 ar rcv libmitgcmuv.a \$(OBJFILES)
2659 ar d libmitgcmuv.a main.o
2660
2661 links: \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(SPECIAL_FILES)
2662
2663 small_f: \$(F77_PP_SRC_FILES) \$(F90_PP_SRC_FILES)
2664
2665 output.txt: \$(EXECUTABLE)
2666 @printf 'running ... '
2667 @\$(EXECUTABLE) > \$@
2668
2669 clean:
2670 -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2671 -rm -rf *.o
2672 -rm -rf *.$FS *.flowdir
2673 -rm -rf *.f$FS90 *_mod.h *_mod.F90 *.FF90 *.mod-whirl ad_input*
2674 -rm -rf temp.sed
2675 Clean:
2676 @make clean
2677 @make cleanlinks
2678 -rm -f \$(SPECIAL_FILES)
2679 -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log f90mkdepend.log *.bak
2680 -rm -f taf_command taf_output taf_ad.log taf_ad_flow.log
2681 CLEAN:
2682 @make Clean
2683 -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2684 -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2685 -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2686 -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2687 -rm -f *_MIT_CE_000.opt0000 costfunction*0000
2688 -rm -rf mnc_test_*
2689
2690 #eh3 Makefile: makefile
2691 makefile:
2692 $THIS_SCRIPT $G2ARGS
2693 cleanlinks:
2694 -find . -type l -exec rm {} \;
2695
2696 # Special targets (SPECIAL_FILES) which are created by make
2697 ${PACKAGES_DOT_H}:
2698 @echo Creating \$@ ...
2699 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
2700 AD_CONFIG.h:
2701 @echo Creating \$@ ...
2702 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
2703 FC_NAMEMANGLE.h:
2704 @echo Creating \$@ ...
2705 echo "$FC_NAMEMANGLE" > \$@
2706
2707 BUILD_INFO.h:
2708 @echo Creating \$@ ...
2709 EOF
2710
2711 test ! "x$THISVER" = x && echo " -echo \"#define THISVER '$THISVER'\" > \$@" >> $MAKEFILE
2712 test ! "x$THISUSER" = x && echo " -echo \"#define THISUSER '$THISUSER'\" >> \$@" >> $MAKEFILE
2713 test ! "x$THISDATE" = x && echo " -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2714 test ! "x$THISHOST" = x && echo " -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2715
2716 if test "x$EMBED_SRC" = xt ; then
2717 cat >>$MAKEFILE <<EOF
2718
2719 decode_files.o : EMBEDDED_FILES.h
2720
2721 ## \$(F77_PP_SRC_FILES)
2722 all_fF.tar.gz : \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(F77_PP_SRC_FILES) Makefile
2723 @echo Creating \$@ ...
2724 -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(F77_PP_SRC_FILES) Makefile
2725 -rm -f all_fF.tar.gz
2726 -gzip all_fF.tar
2727
2728 EMBEDDED_FILES.h : all_fF.tar.gz
2729 @echo Creating \$@ ...
2730 -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2731
2732 EOF
2733 fi
2734
2735 cat >>$MAKEFILE <<EOF
2736
2737 # The normal chain of rules is ( .F - .$FS - .o )
2738
2739 ## This nullifies any default implicit rules concerning these two file types:
2740 ## %.o : %.F
2741
2742 .F.$FS:
2743 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2744 .$FS.o:
2745 \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2746 .F90.$FS90:
2747 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2748 .FF90.f$FS90:
2749 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2750 .$FS90.o:
2751 \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2752 .f$FS90.o:
2753 cp \$< \$(basename \$<).f90
2754 \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$(F90FIXEDFORMAT) \$(basename \$<).f90
2755 .c.o:
2756 \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2757 .flow.flowdir:
2758 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2759
2760 # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2761 .F.p:
2762 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2763 .p.$FS:
2764 \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2765
2766 EOF
2767
2768 #=========================================
2769 #=== Automatic Differentiation Rules ===
2770 #=== for TAMC/TAF ======================
2771
2772 if test "x$OPENAD" == x ; then
2773
2774 cat >>$MAKEFILE <<EOF
2775
2776 TAMC = ${TAMC}
2777 TAF = ${TAF}
2778
2779 TAF_EXTRA = ${TAF_EXTRA}
2780 TAMC_EXTRA = ${TAMC_EXTRA}
2781
2782 EOF
2783
2784 ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
2785 ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
2786 ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2787 for i in $ad_vars ; do
2788 name=$i
2789 t1="t2=\$"`echo "$i"`
2790 eval $t1
2791 printf "%-20s = " $name >> $MAKEFILE
2792 echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2793 done
2794
2795 echo " Add the source list for AD code generation"
2796 echo >> $MAKEFILE
2797 printf "AD_FILES = " >> $MAKEFILE
2798 AD_FILES=`cat adSrcFiles.tmp`
2799 for i in $AD_FILES ; do
2800 echo " \\" >> $MAKEFILE
2801 printf " $i" >> $MAKEFILE
2802 done
2803 echo >> $MAKEFILE
2804 rm -f adSrcFiles.tmp
2805
2806 cat >>$MAKEFILE <<EOF
2807
2808 # ... AD ...
2809 adall: \$(EXE_AD)
2810 adtaf: ad_taf_output.$FS
2811 adtamc: ad_tamc_output.$FS
2812
2813 ad_input_code.$FS: \$(AD_FILES) \$(H_SRC_FILES)
2814 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2815 cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2816 -rm -f ad_config.template
2817 @make \$(F77_PP_SRC_FILES)
2818 @make \$(FLOFILES)
2819 cat \$(FLOFILES) \$(AD_FILES) > ad_input_code.$FS
2820
2821 ad_taf_output.$FS: ad_input_code.$FS
2822 \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2823 ls -l ad_input_code_ad.$FS
2824 cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2825
2826 adtafonly:
2827 \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2828 ls -l ad_input_code_ad.$FS
2829 cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2830
2831 \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2832 \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2833
2834 ad_tamc_output.$FS: ad_input_code.$FS
2835 \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS
2836 cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.$FS
2837
2838 ad_tamc: ad_tamc_output.o \$(OBJFILES)
2839 \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
2840
2841 adonlyfwd:
2842 patch < \$(TOOLSDIR)/ad_taf_output.f.onlyfwd.diff
2843
2844 adtrick:
2845 patch < \$(TOOLSDIR)/ad_taf_output.f.adtrick.diff
2846
2847 # ... FTL ...
2848 ftlall: ftl_taf
2849 ftltaf: ftl_taf_output.$FS
2850 ftltamc: ftl_tamc_output.$FS
2851
2852 ftl_input_code.$FS: \$(AD_FILES) \$(H_SRC_FILES)
2853 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2854 cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2855 -rm -f ftl_config.template
2856 @make \$(F77_PP_SRC_FILES)
2857 @make \$(AD_FLOW_FILES)
2858 cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS
2859
2860 ftl_taf_output.$FS: ftl_input_code.$FS
2861 \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2862 ls -l ftl_input_code_ftl.$FS
2863 cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2864
2865 ftltafonly:
2866 \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2867 ls -l ftl_input_code_ftl.$FS
2868 cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2869
2870 ftl_taf: ftl_taf_output.o \$(OBJFILES)
2871 \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2872
2873 ftl_tamc_output.$FS: ftl_input_code.$FS
2874 \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.$FS
2875 cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.$FS
2876
2877 ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2878 \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2879
2880
2881 # ... SVD ...
2882 svdtaf: ad_taf_output.$FS ftl_taf_output.$FS
2883 @echo "--->>> Only ran TAF to generate SVD code! <<<---"
2884 @echo "--->>> Do make svdall afterwards to compile. <<<---"
2885 svdall: svd_touch svd_taf
2886
2887 svd_taf: \$(OBJFILES)
2888 \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2889
2890 @echo "--->>> Only COMPILE svd code! <<<---"
2891 @echo "--->>> Assumes you previously <<<---"
2892 @echo "--->>> did make svdtaf <<<---"
2893
2894 svd_touch:
2895 @echo "--->>> Only COMPILE svd code! <<<---"
2896 @echo "--->>> Assumes you previously <<<---"
2897 @echo "--->>> did make svdtaf <<<---"
2898 touch ad_taf_output.$FS ftl_taf_output.$FS
2899 \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.$FS
2900 \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.$FS
2901 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2902 cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2903 -rm -f ftl_config.template
2904
2905 EOF
2906
2907 fi
2908
2909 #=== for OpenAD ========================
2910
2911 if test "x$OPENAD" != x ; then
2912
2913 # ============ begin OpenAD specific section ==============
2914
2915 cat >>$MAKEFILE <<EOF
2916
2917 # all the source files linked from the various locations:
2918 ALL_LINKED_FILES= \
2919 \$(F77_SRC_FILES) \
2920 \$(C_SRC_FILES) \
2921 \$(H_SRC_FILES) \
2922 \$(F90_SRC_FILES) \
2923 \$(SPECIAL_FILES)
2924
2925 ifndef OPENADROOT
2926 \$(error "Error: environment variable OPENADROOT not defined!")
2927 endif
2928
2929 ifndef XAIFSCHEMAROOT
2930 \$(error "Error: environment variable XAIFSCHEMAROOT not defined!")
2931 endif
2932
2933 ifndef XAIFBOOSTERROOT
2934 \$(error "Error: environment variable XAIFBOOSTERROOT not defined!")
2935 endif
2936
2937 EOF
2938
2939 echo " Add the source list for common block to module conversion "
2940 echo >> $MAKEFILE
2941 printf "CB2M_F90_SRC_NAMES = " >> $MAKEFILE
2942 for i in `cat ${OAD_CB2M_FILES}` ; do
2943 echo " \\" >> $MAKEFILE
2944 printf " $i" >> $MAKEFILE
2945 done
2946 echo >> $MAKEFILE
2947
2948 echo " Add the source list for AD code generation"
2949 echo >> $MAKEFILE
2950 printf "AD_FILES = " >> $MAKEFILE
2951 for i in `cat ${OAD_CB2M_FILES}` ; do
2952 echo " \\" >> $MAKEFILE
2953 printf " ${i}_mod.f$FS90" >> $MAKEFILE
2954 done
2955 AD_FILES=`cat adSrcFiles.tmp`
2956 for i in $AD_FILES ; do
2957 basename=${i%%.f}
2958 toBeIgnored=`egrep ^$basename'[ ]*' ${OAD_DONT_COMPILE} ${OAD_DONT_TRANSFORM}`
2959 if test -z "$toBeIgnored" ; then
2960 echo " \\" >> $MAKEFILE
2961 printf " $i" >> $MAKEFILE
2962 fi
2963 done
2964 echo >> $MAKEFILE
2965 rm -f adSrcFiles.tmp
2966
2967 cat >>$MAKEFILE <<EOF
2968
2969 adAll: \$(EXE_AD)
2970 .PHONY: adAll
2971
2972 CB2M_F90_PP_SRC_FILES=\$(addsuffix _mod.f$FS90, \$(CB2M_F90_SRC_NAMES))
2973
2974 .PRECIOUS: \$(CB2M_F90_PP_SRC_FILES) \$(NON_AD_F77_SRC_FILES:.F=_cb2m.f$FS90)
2975
2976 .PHONY: adDepend
2977 adDepend: \$(ALL_LINKED_FILES) \$(addsuffix _mod.h, \$(CB2M_F90_SRC_NAMES)) \$(addsuffix _mod.FF90, \$(CB2M_F90_SRC_NAMES)) \$(F77_SRC_FILES:.F=_cb2m.FF90)
2978 \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(F77_SRC_FILES)
2979 \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2980 -rm -f makedepend.out
2981
2982 OPENAD_SUPPORT_F90_SRC_FILES = \
2983 w2f__types.F90 \
2984 OAD_active.F90 \
2985 OAD_cp.F90 \
2986 OAD_rev.F90 \
2987 OAD_tape.F90
2988
2989 OPENAD_SUPPORT_C_SRC_FILES = \
2990 iaddr.c \
2991 timeRatio.c
2992
2993 f95_test_mods.f90: \$(OPENAD_SUPPORT_F90_SRC_FILES:F90=$FS90)
2994 cat \$^ > \$@
2995
2996 f95_test.f90: all_mods.xb.x2w.w2f.pp.f$FS90 \$(NON_AD_F77_SRC_FILES:.F=_cb2m.f$FS90) ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
2997 cat \$^ > \$@
2998
2999 f95_test.out: f95_test_mods.f90 f95_test.f90
3000 f95 -fixed -w=unused -maxcontin=132 -c f95_test_mods.f90 > \$@ 2>&1
3001 f95 -fixed -w=unused -maxcontin=132 -c -fixed f95_test.f90 >> \$@ 2>&1
3002
3003 AD_OBJ_FILES=\$(OPENAD_SUPPORT_F90_SRC_FILES:.F90=.o) \$(OPENAD_SUPPORT_C_SRC_FILES:.c=.o) all_mods.xb.x2w.w2f.pp.o ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.o \$(NON_AD_F77_SRC_FILES:.F=_cb2m.o) \$(C_SRC_FILES:.c=.o) \$(F90_SRC_FILES:.F90=.o)
3004
3005 \$(EXE_AD): \$(ALL_LINKED_FILES) \$(addsuffix _mod.h, \$(CB2M_F90_SRC_NAMES)) \$(AD_OBJ_FILES)
3006 @echo Creating \$@ ...
3007 \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(AD_OBJ_FILES) \$(LIBS)
3008
3009 # makefile debug rule
3010 openad: ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
3011 .PHONY: openad
3012
3013 # create the module files
3014 %_mod.FF90 : %.h ../OAD_support/cb2mGetModules.csh ../OAD_support/cb2mGetModules.awk
3015 ../OAD_support/cb2mGetModules.csh $< ../OAD_support/cb2mGetModules.awk
3016
3017 # create the header files
3018 %_mod.h : %.h ../OAD_support/cb2mGetHeaders.csh ../OAD_support/cb2mGetHeaders.awk
3019 ../OAD_support/cb2mGetHeaders.csh $< ../OAD_support/cb2mGetHeaders.awk \$(CB2M_F90_SRC_NAMES)
3020
3021 # change everybody else to use the new module files:
3022 %_cb2m.FF90 : %.F ../OAD_support/cb2mUseModules.bash
3023 ../OAD_support/cb2mUseModules.bash $< ${MPI}
3024
3025 # makefile debug rule
3026 small_f: \$(CB2M_F90_PP_SRC_FILES)
3027 .PHONY: small_f
3028
3029 ad_output.txt: \$(EXE_AD)
3030 @printf 'linking data files ... '
3031 \$(LN) -f ../input_ad/data* ../input_ad/eedata .
3032 \$(LN) -f ../../global_ocean.90x40x15/input/*.bin .
3033 @printf 'running ... '
3034 @./\$(EXE_AD) > \$@
3035
3036 CB2M_AD_FILES=\$(AD_FILES:.f=_cb2m.f$FS90)
3037 ad_input_code.f$FS90: ../OAD_support/maxMinDefs.f \$(CB2M_AD_FILES)
3038 cat \$^ > \$@
3039
3040 # strip all comments and blanks to reduce
3041 # the file size in order to reduce perl's memory requirements
3042 ad_input_code_sf.f$FS90 : ad_input_code.f$FS90
3043 cat \$^ | sed -f ../OAD_support/strip.sed | sed -f ../OAD_support/stop2print.sed > \$@
3044
3045 # mfef90 preprocessing
3046 # expand statement functions
3047 # expose mfef90 specific substring handling
3048 # add the w2f__types module
3049 ad_input_code_sf.w2f.f$FS90: ad_input_code_sf.f$FS90 mfef90 whirl2f whirl2f_be w2f__types.f90
3050 ./mfef90 -r8 -z -F -N132 \$<
3051 mv \$<.B \$(basename \$<).B
3052 ./whirl2f -openad \$(basename \$<).B
3053 cat w2f__types.f90 \$(basename \$<).w2f.f > \$@
3054
3055 # canonicalizer
3056 ad_input_code_sf.w2f.pre.f$FS90: ad_input_code_sf.w2f.f$FS90 preProcess.py
3057 ./preProcess.py -H -S \$< -o \$@
3058
3059 # F -> WHIRL
3060 # note that the canonicalized version cuts off at col 72
3061 # doing this also for string constants which is ok as long
3062 # as we are in fixed mode and cut of exactly there.
3063 # Otherwise mfef90 patches in spaces to fill up to 72 (or 132)
3064 # characters respectively.
3065 ad_input_code_sf.w2f.pre.B: ad_input_code_sf.w2f.pre.f$FS90 mfef90
3066 ./mfef90 -r8 -z -F \$<
3067 mv \$<.B \$@
3068
3069 # WHIRL -> XAIF
3070 ad_input_code_sf.w2f.pre.xaif : ad_input_code_sf.w2f.pre.B whirl2xaif
3071 ./whirl2xaif -s -n --debug 1 -o \$@ \$<
3072
3073 # XAIF -> XAIF'
3074 ad_input_code_sf.w2f.pre.xb.xaif : ad_input_code_sf.w2f.pre.xaif xaif.xsd xaif_base.xsd xaif_inlinable_intrinsics.xsd xaif_derivative_propagator.xsd xaif_output.xsd oadDriver
3075 ./oadDriver -f -t forward_step -i \$< -c \${XAIFSCHEMAROOT}/schema/examples/inlinable_intrinsics.xaif -o \$@ -I -r
3076
3077 # XAIF' -> WHIRL'
3078 ad_input_code_sf.w2f.pre.xb.x2w.B : ad_input_code_sf.w2f.pre.xb.xaif xaif2whirl
3079 ./xaif2whirl --debug 1 --structured ad_input_code_sf.w2f.pre.B \$<
3080
3081 # WHIRL' -> F'
3082 ad_input_code_sf.w2f.pre.xb.x2w.w2f.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.B whirl2f whirl2f_be
3083 ./whirl2f -FLIST:ftn_file=\$@ -openad \$<
3084
3085 # insert template directives
3086 ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.f$FS90 ../OAD_support/insertTemplateDir.bash
3087 ../OAD_support/insertTemplateDir.bash \$< \$@
3088
3089 PPEXTRAS=\$(wildcard ../OAD_support/ad_template.*.F) ../OAD_support/ad_inline.F
3090 # postprocess F'
3091 ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.pp.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.f$FS90 multi-pp.pl \$(PPEXTRAS:.F=.f)
3092 perl multi-pp.pl -inline=../OAD_support/ad_inline.f \$<
3093 # the postprocessor still gets the name wrong
3094 cat \$<.pp | sed 's/RETURN//' > \$@
3095
3096 # extract all transformed modules
3097 all_mods.xb.x2w.w2f.pp.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
3098 cat \$< | sed -n '/MODULE /,/END MODULE/p' > \$@
3099
3100 # remove the transformed globals module from the
3101 # transformed ad_input_code file
3102 # and remove for now the duplicate variables
3103 # and fix 2 data statements
3104 ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
3105 cat \$< | sed '/MODULE /,/END MODULE/d' | sed '/^ INTEGER(w2f__i4) DOLOOP_UB/d' > \$@
3106
3107 # setup some links
3108 %.xsd:
3109 \$(LN) \${XAIFSCHEMAROOT}/schema/\$@ .
3110
3111 mfef90:
3112 \$(LN) \${OPEN64ROOT}/crayf90/sgi/mfef90 .
3113
3114 # link the support files:
3115 \$(OPENAD_SUPPORT_F90_SRC_FILES) \$(OPENAD_SUPPORT_C_SRC_FILES):
3116 \$(LN) ../OAD_support/\$@ .
3117
3118 whirl2xaif xaif2whirl:
3119 \$(LN) \${OPENADFORTTK}/bin/\$@ .
3120
3121 %.pl:
3122 \$(LN) \${OPENADFORTTK}/bin/\$@ .
3123
3124 preProcess.py:
3125 \$(LN) \${OPENADFORTTK_BASE}/tools/SourceProcessing/\$@ .
3126
3127 whirl2f whirl2f_be:
3128 \$(LN) \${OPEN64ROOT}/whirl2f/\$@ .
3129
3130 oadDriver:
3131 \$(LN) \${XAIFBOOSTERROOT}/xaifBooster/algorithms/BasicBlockPreaccumulationReverse/driver/oadDriver \$@
3132
3133 # ============ end OpenAD specific section ==============
3134
3135 EOF
3136
3137 fi
3138
3139 #=========================================
3140
3141 if test "x$EXEHOOK" != x ; then
3142 printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE
3143 fi
3144
3145 echo " Making list of \"exceptions\" that need \".p\" files"
3146 for i in $KPPFILES ; do
3147 base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
3148 RETVAL=$?
3149 if test "x$RETVAL" != x0 ; then
3150 echo "Error: unable to add file \"$i\" to the exceptions list"
3151 fi
3152 echo "$base.$FS: $base.p" >> $MAKEFILE
3153 done
3154
3155 echo " Making list of NOOPTFILES"
3156 for i in $NOOPTFILES ; do
3157 base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
3158 RETVAL=$?
3159 if test "x$RETVAL" != x0 ; then
3160 echo "Error: unable to add file \"$i\" to the exceptions list"
3161 fi
3162 echo "$base.o: $base.$FS" >> $MAKEFILE
3163 printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
3164 done
3165
3166 echo " Add rules for links"
3167 cat srclinks.tmp >> $MAKEFILE
3168 rm -f srclinks.tmp
3169
3170 echo " Adding makedepend marker"
3171 printf "\n\n# DO NOT DELETE\n" >> $MAKEFILE
3172
3173 printf "\n=== Done ===\n"
3174
3175 # Create special header files
3176 $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
3177 if test ! -f $PACKAGES_DOT_H ; then
3178 mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
3179 else
3180 cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
3181 RETVAL=$?
3182 if test "x$RETVAL" = x0 ; then
3183 rm -f $PACKAGES_DOT_H".tmp"
3184 else
3185 mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
3186 mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
3187 fi
3188 fi
3189 if test ! -f AD_CONFIG.h ; then
3190 $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
3191 fi
3192
3193
3194 # Write the "state" for future records
3195 if test "x$DUMPSTATE" != xf ; then
3196 printf "" > genmake_state
3197 for i in $gm_state ; do
3198 t1="t2=\$$i"
3199 eval $t1
3200 echo "$i='$t2'" >> genmake_state
3201 done
3202 fi

  ViewVC Help
Powered by ViewVC 1.1.22